#include<iostream>
#include<queue>
using namespace std;

const int MAXN = 5000;

vector<int> graph[MAXN];
bool v[MAXN];
vector<int> edges;
int nodes=0;

void BFS(int idx)
{
    queue<int> q;
    q.push(idx);

    while(!q.empty())
    {
        idx=q.front();
        q.pop();

        if(v[idx])
        {
            continue;
        }
        v[idx]=true;

        edges.push_back(idx);
        nodes+=graph[idx].size();

        for(int x:graph[idx])
        {
            q.push(x);
        }
    }
}

int main()
{
    //ios_base::sync_with_stdio(0);
    //cin.tie(0);

    int n;
    cin >> n;

    for(int i=0; i<n-1; i++)
    {
        v[i]=false;
        string row;
        cin >> row;

        for(int j=0; j<n-1-i; j++)
        {
            if(row[j]=='1')
            {
                graph[i].push_back(j+i+1);
                graph[j+i+1].push_back(i);
            }
        }
    }

    /*for(int i=0; i<n; i++)
    {
        cout << i << " -> ";
        for(int x:graph[i])
        {
            cout << x << " ";
        }
        cout << "\n";
    }*/

    int ans=-1;
    for(int i=0; i<n; i++)
    {
        if(!v[i])
        {
            edges.clear();
            nodes=0;
            BFS(i);

            nodes/=2;

            if(edges.size()>=4)
            {
                if(nodes>=edges.size())
                {
                    if(ans==-1 || ans>3)
                    {
                        ans=3;
                    }
                }
                else
                {
                    int cnt=0;
                    for(int x:edges)
                    {
                        if(graph[x].size()>=2)
                        {
                            cnt++;
                        }
                    }

                    if(cnt>=2 && (ans==-1 || ans>4))
                    {
                        ans=4;
                    }
                }
            }
        }
    }

    cout << ans << "\n";

    return 0;
}
