#include<bits/stdc++.h>
#define endl '\n'
using namespace std;
const int MAX_NM = 1e6+2;
const int INF = 1e9+7;
vector<vector<bool>> a;
int dist[MAX_NM];
bool first_in_row[MAX_NM];
bool first_in_col[MAX_NM];
int dp[MAX_NM];
int n,m;
char c;
int code(int i0, int j0)
{
    return i0*m+j0;
}
pair<int,int> decode(int num)
{
    return {num/m,num%m};
}
void solve()
{
    cin>>n>>m;
    a.resize(n,vector<bool>(m));
    for(int i=0; i<n; i++)
    {
        for(int j=0; j<m; j++)
        {
            cin>>c;
            if(c == '.') a[i][j] = 0;
            else a[i][j] = 1;
        }
    }
    for(int j=0; j<m; j++)
    {
        if(a[0][j] == 1) continue;
        int delta = 0;
        for(int p=j+1; p<m; p++)
        {
            if(a[0][p] == 1) delta++;
            else break;
        }
        int idx = j;
        for(int add=dp[j]+1+delta; ;)
        {
            idx += add;
            if(idx >= m) break;
            else dp[idx] = add;
            add++;
        }
        idx = j;
        for(int add=dp[j]+2+delta; ;)
        {
            idx += add;
            if(idx >= m) break;
            else dp[idx] = add;
            add++;
        }
    }
    if(dp[m-1]) cout<<dp[m-1]<<endl;
    else cout<<-1<<endl;
    return;
}
int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    solve();
}
/**
1 60
............................................................
8
0  1 2  2 3 3 3 4 4 4 4 5 5 5 5 5 6 6 6 6 6 6 7 7 7 7 7 7 7 8 8 8 8 8 8 8 8 9 9 9 9 9 9  9  9 9 10 10 10 10 10 10 10 10 10 10 11 11 11 11
11
0 -1 2  3 4 3 4 4 5 4 5 5 5 6 5 6 6 6 6 7 6 7 7 7 7 7 8 7 8 8 8 8 8 8 9 8 9 9 9 9 9 9 9 10 9 10 10 10 10 10 10 10 10 11 10 11 11 11 11 11
11
0 1 -1  2 3 4 3 4 4 5 4 5 5 5 6 5 6 6 6 6 7 6 7 7 7 7 7 8 7 8 8 8 8 8 8 9 8 9 9 9 9 9 9  9 10 9 10 10 10 10 10 10 10 10 11 10 11 11 11 11
11
0 1  2 -1 3 3 4 5 4 4 5 5 6 5 5 6 6 6 7 6 6 7 7 7 7 8 7 7 8 8 8 8 8 9 8 8 9 9 9 9 9 9 10 9 9 10 10 10 10 10 10 10 11 10 10 11 11 11 11 11
8
0 -1 -1 3 4 5 6 4 5 5 6 6 5 6 6 6 7 7 6 7 7 7 7 8 8 7 8 8 8 8
*/

