#include<bits/stdc++.h>
#define pb push_back
using namespace std;

template<class T> using matrix = vector<vector<T>>;

const int MAXN = 2e3 + 3;

int N, sz;
matrix<int> G;
vector<int> used;
bitset<MAXN> adj[MAXN];

void dfs(int u){
    used[u] = true;
    sz ++;
    for(auto v : G[u]) if(!used[v]){
        dfs(v);
    }
}

int main(){
    cin >> N;
    G = matrix<int>(N + 1);
    used = vector<int>(N + 1);
    for(int u = 1; u < N; u ++){
        for(int  v = u + 1; v <= N; v ++){
            int x; cin >> x;
            if(x){
                G[u].pb(v);
                G[v].pb(u);
                adj[u] |= 1 << v;
                adj[v] |= 1 << u;
            }
        }
    }
    int ans = 1e9;
    for(int u = 1; u <= N; u ++){
        if(!used[u]){
            sz = 0;
            dfs(u);
            if(sz > 3){
                ans = 4;
            }
        }
    }
    if(ans == 1e9){ cout << "-1\n"; return 0; }
    for(int u = 1; u <= N; u ++){
        for(int v = 1; v <= N; v ++){
            bool rem = false;
            if(adj[u][v]){
                rem = true;
                adj[u][v] = adj[v][u] = false;
            }
            if((adj[u] & adj[v]).count() > 2){
                ans = 2;
            }
            if(rem){
                adj[u][v] = adj[v][u] = true;
            }
        }
    }
    if(ans == 1e9) cout << "-1\n";
    else cout << ans << endl;
}
