#include<bits/stdc++.h>
using namespace std;
const int maxn = 5006;
const int maxm = 25000006;
vector <int> v[maxn];
int i,j,p,q,n,m,k,tin[maxn],tout[maxn],dep[maxn],sz[maxn],par[maxn],br,ans,l,cnt[maxn][maxn];
vector <int> up[maxn];
vector <pair <int,int>> edges;
vector <int> loshi[maxn];
bool b[maxm];
bool vis[maxn];
string s;
int Find(int u)
{
    if(par[u]==u)
        return u;
    return par[u]=Find(par[u]);
}
void Union(int a,int b)
{
    a = Find(a);
    b = Find(b);
    if(a==b)
        return ;
    if(sz[a]<sz[b])
        swap(a,b);
    par[b]=a;
    sz[a]+=sz[b];
}
void dfs(int u,int p)
{
    //cout<<u<<" "<<p<<endl;
    tin[u]=++br;
    vis[u]=1;
    up[u][0]=p;
    for(int k=1;k<=l;k++)
    {
        up[u][k]=up[up[u][k-1]][k-1];
    }
    for(auto j:v[u])
    {
        if(j==p)continue;
        dep[j]=dep[u]+1;
        if(dep[j]==3)
            ans=4;///!
        dfs(j,u);
    }
    tout[u]=br;
}
bool upper(int a,int b)
{
    return (tin[a]<=tin[b] && tout[a]>=tout[b]);
}
int LCA(int a,int b)
{
    for(int j=l;j>=0;j--)
    {
        if(!upper(up[a][j],b))
            a=up[a][j];
    }
    return up[a][0];
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    cin>>n;
    for(i=1;i<=n;i++)
        par[i]=i,sz[i]=1;
    while((1<<l)<=n)
        l++;
    for(i=0;i<=n+2;i++)
    {
        up[i].resize(l+3);
    }
    tout[0] = INT_MAX;
    for(i=1;i<n;i++)
    {
        cin>>s;
        for(j=0;j<n-i;j++)
        {
            if(s[j]=='1')
            {
                //cout<<i<<" "<<i+j+1<<endl;
                edges.push_back({i,j+i+1});
            }
        }
    }
    j = 0;
    for(auto i:edges)
    {
        p = i.first;
        q = i.second;
        p = Find(p);
        q = Find(q);
        if(p!=q)
        {
            b[j]=1;
            Union(p,q);
            //cout<<i.first<<" "<<i.second<<endl;
            v[i.first].push_back(i.second);
            v[i.second].push_back(i.first);
        }
        j++;
    }
    ans = INT_MAX;
    for(i=1;i<=n;i++)
    {
        if(!vis[i])
        {
            dfs(i,0);
        }
    }

    for(i=0;i<edges.size();i++)
    {
        p = edges[i].first;
        q = edges[i].second;
        if(!b[i])
        {
            loshi[p].push_back(q);
            loshi[q].push_back(p);
        }
    }

    for(i=0;i<edges.size();i++)
    {
        if(!b[i])
        {
            p=edges[i].first;
            q=edges[i].second;
            if(upper(p,q))
            {
                j = dep[q]-dep[p]+1;
                if(j<4)continue;
                ans = min(ans,j-2);
            }
            else if(upper(q,p))
            {
                j = dep[p]-dep[q]+1;
                if(j<4)continue;
                ans=min(ans,j-2);
            }
            else
            {
                k = LCA(p,q);
                j = dep[p]+dep[q]-2*dep[k]+1;
                if(dep[p]==1 && dep[q]==1)///ima znachenie kum koi vruh sa
                    cnt[k][p]++,cnt[k][q]++;
                if(cnt[k][p]==2 || cnt[k][q]==2)
                {
                    cout<<2<<endl;
                    return 0;
                }
                int pp = up[p][0];
                int qq = up[q][0];
                for(auto jj:loshi[pp])
                {
                    if(upper(jj,q) && jj!=q)
                        ans=min(ans,dep[q]-dep[jj]);
                }
                for(auto jj:loshi[qq])
                {
                    if(upper(jj,p) && jj!=p)
                        ans=min(ans,dep[p]-dep[jj]);
                }
                if(j<4)continue;
                //cout<<p<<" "<<q<<" "<<k<<endl;
                ans = min(ans,j-2);
            }
        }
    }

    if(ans!=INT_MAX)
        cout<<ans<<endl;
    else cout<<-1<<endl;
    return 0;
}
/**
9 10
1 2
1 8
2 3
3 6
6 8
3 4
4 5
5 9
4 7
1 9

9
10000011
1000000
101000
10100
0001
010
00
0


*/
