#include <bits/stdc++.h>
// #pragma GCC optimize("Ofast")
// #pragma GCC target("sse4")
using namespace std;

#ifndef LOCAL
#define cerr if(false)cerr
#endif // LOCAL
#define endl "\n"

template<class T, class T2> bool chkmin(T &a, const T2 &b) { return (a > b) ? a = b, 1 : 0; }
template<class T, class T2> bool chkmax(T &a, const T2 &b) { return (a < b) ? a = b, 1 : 0; }

#define out(x) "[" << #x << "=" << x << "]"

template<class T> ostream &operator <<(ostream &out, const vector<T> &arr) {
    for(const auto &it : arr) { out << it << " "; }
    return out;
}

struct debug {
    debug(const string &out = "") { cerr << "DEBUGGER " << out <<  ": "; }
    ~debug() { cerr << endl; }

    template<class T>
    debug& operator <<(const T& a) {
        cerr << a << " ";
        return *this;
    }
};

#define dbg debug(to_string(__LINE__))
#define dbg_(x) debug(to_string(__LINE__) + "_" + x)

typedef long long ll;
const ll mod = 1e9 + 7;
///----------------------------------------------///

const int MAX_N = 1e6 + 10;
int dp[2][MAX_N];
int n, m;
string tab[MAX_N];
vector<pair<int, int> > who[MAX_N];
vector<pair<int, int> > already;

signed main() {
    /// ios_base::sync_with_stdio(false); cin.tie(NULL); cout.tie(NULL);

    cin >> n >> m;
    for(int i = 0; i < n; i ++) {
        cin >> tab[i];
    }

    for(int i = 0; i < n; i ++) {
        for(int j = 0; j < m; j ++) {
            dp[i][j] = mod;
        }
    }

    who[1].push_back({0, 0});
    dp[0][0] = 1;
    already = {};
    for(int t = 0; t < MAX_N; t ++) {
        for(const auto &it : who[t]) {
            if(dp[it.first][it.second] == t && tab[it.first][it.second] != '#') {
                already.push_back(it);
                if(it.first == n - 1  && it.second == m - 1) {
                    cout << t - 1 << endl;
                    return 0;
                }
            }
        }

        for(const auto &it : already) {
            if(it.first > t && chkmin(dp[it.first - t][it.second], t + 1)) { who[t + 1].push_back({it.first - t, it.second}); }
            if(it.second > t && chkmin(dp[it.first][it.second - t], t + 1)) { who[t + 1].push_back({it.first, it.second - t}); }
            if(it.first + t < n && chkmin(dp[it.first + t][it.second], t + 1)) { who[t + 1].push_back({it.first + t, it.second}); }
            if(it.second + t < m && chkmin(dp[it.first][it.second + t], t + 1)) { who[t + 1].push_back({it.first, it.second + t}); }
        }
    }

    if(dp[n - 1][m - 1] == mod) {
        cout << -1 << endl;
    } else {
        cout << dp[n - 1][m - 1] - 1 << endl;
    }

    return 0;
}

/// Tova e prekrasno, nali?


