#include <bits/stdc++.h>
using namespace std;

const int inf = 1000000000;
int min_cycle = inf, min_pseudo = inf;
int n;
char c;
int table[5003][5003];
vector <int> nbs[5003];
bool used[5003];
int level[5003];

void dfs (int curr) {
    //cout << "now " << curr << " s level " << level[curr] << endl;
    used[curr] = true;
    for (int i=0; i < nbs[curr].size(); i++) {
        int currn = nbs[curr][i];
        //cout << "now sused " << currn << " s used " << used[currn] << endl;
        if (used[currn] == true) {
            if (abs(level[curr] - level[currn]) >= 3) {
                min_cycle = min (min_cycle, abs(level[curr] - level[currn]) + 1);
                //cout << "consider cycle " << curr << " s level " << level[curr] << " i " << currn << " s level " << level[currn] << endl;
            }
            if (level[curr] != 0 and level[currn] != 0 and abs(level[curr] - level[currn]) >= 2) {
                //cout << "consider pseudo " << curr << " s level " << level[curr] << " i " << currn << " s level " << level[currn] << endl;
                min_pseudo = min (min_pseudo, abs(level[curr] - level[currn]) + 1);
            }
        }
        else {
            level[currn] = level[curr] + 1;
            dfs(currn);
            used[currn] = false;
        }
    }
    used[curr] = false;
    level[curr] = -1;
}

int main () {
ios_base::sync_with_stdio(false);
cin.tie(0); cout.tie(0);

cin >> n;

for (int i=1; i <= n-1; i++) {
    for (int j=i+1; j <= n; j++) {
        cin >> c;
        if (c == '1') {
            nbs[i].push_back(j);
            nbs[j].push_back(i);
            table[i][j] = 1; table[j][i] = 1;
        }
    }
}

/**for (int i=1; i <= n; i++) {
    for (int j=1; j <= n; j++) {
        cout << table[i][j] << " ";
    }
    cout << endl;
}

for (int i=1; i <= n; i++) {
    cout << "susedi na " << i << ": ";
    for (int j=0; j < nbs[i].size(); j++) {
        cout << nbs[i][j] << " ";
    }
    cout << endl;
}**/

for (int i=0; i < 5003; i++) {used[i] = false; level[i] = -1;}

level[1] = 0;
dfs (1);

//cout << min_cycle << " " << min_pseudo << endl;

int answer = inf;

if (min_cycle == 4) {answer = min (answer, 2);}
else if (min_cycle == 5) {answer = min(answer, 3);}
else if (min_cycle > 5 and min_cycle != inf) {answer = min (answer, 4);}
if (min_pseudo == 3) {answer = min (answer, 3);}
else if (min_pseudo >= 4 and min_pseudo != inf) {answer = min (answer, 3);}
if (answer != inf) {cout << answer << endl;}
else {cout << -1 << endl;}

return 0;
}
