#include <bits/stdc++.h>
using namespace std;

const int inf = 1000000000;
int min_cycle = inf, min_pseudo = inf;
int n;
char c;
int table[5003][5003];
vector <int> nbs[5003];
bool used[5003];
int level[5003];
bool found=false;
bool found4=false, found5=false, found3=false;

void dfs (int curr) {
    //cout << "now " << curr << " s level " << level[curr] << endl;
    if (found == true) {return;}
    used[curr] = true;
    for (int i=0; i < nbs[curr].size(); i++) {
        int currn = nbs[curr][i];
        //cout << "now sused " << currn << " s used " << used[currn] << endl;
        if (used[currn] == true) {
            if (abs(level[curr] - level[currn]) >= 3) {
                min_cycle = min (min_cycle, abs(level[curr] - level[currn]) + 1);
                found = true;
                break;
                //cout << "consider cycle " << curr << " s level " << level[curr] << " i " << currn << " s level " << level[currn] << endl;
            }
            if (level[curr] != 0 and level[currn] != 0 and abs(level[curr] - level[currn]) >= 2) {
                //cout << "consider pseudo " << curr << " s level " << level[curr] << " i " << currn << " s level " << level[currn] << endl;
                min_pseudo = min (min_pseudo, abs(level[curr] - level[currn]) + 1);
            }
        }
        else {
            level[currn] = level[curr] + 1;
            dfs(currn);
            used[currn] = false;
        }
    }
    if (found == true) {return;}
    used[curr] = false;
    level[curr] = -1;
}

void cycle (vector <int> dosega) {
    if (found4 == true) {return;}
    if (found4 == true and (found5 == true or found3 == true)) {return;}
    int curr_size = dosega.size();
    if (curr_size <= 4) {
        if (curr_size == 3) {
            if (table[dosega[2]][dosega[0]] == 1) {
                if (nbs[dosega[0]].size() > 2 or nbs[dosega[1]].size() > 2 or nbs[dosega[2]].size() > 2) {
                    found3 = true;
                }
            }
        }
        if (curr_size == 4) {
            if (table[dosega[3]][dosega[0]] == 1) {
                //for (int i=0; i < curr_size; i++) {cout << dosega[i] << " ";}
                //cout << endl;
                found4 = true;
                return;
            }
        }
        int curr = dosega[curr_size-1];
        for (int i=0; i < nbs[curr].size(); i++) {
            int currn = nbs[curr][i];
            bool k1=false;
            for (int j=0; j < curr_size; j++) {
                if (currn == dosega[j]) {k1=true; break;}
            }
            if (k1 == true) {continue;}
            dosega.push_back(currn);
            cycle(dosega);
            dosega.pop_back();
        }
    }
    else if (curr_size == 5) {
        if (table[dosega[4]][dosega[0]] == 1) {
            //for (int i=0; i < curr_size; i++) {cout << dosega[i] << " ";}
            //cout << endl;
            found5 = true;
            return;
        }
    }
    else {return;}
}

int main () {
ios_base::sync_with_stdio(false);
cin.tie(0); cout.tie(0);

cin >> n;

for (int i=1; i <= n-1; i++) {
    for (int j=i+1; j <= n; j++) {
        cin >> c;
        if (c == '1') {
            nbs[i].push_back(j);
            nbs[j].push_back(i);
            table[i][j] = 1; table[j][i] = 1;
        }
    }
}

/**for (int i=1; i <= n; i++) {
    for (int j=1; j <= n; j++) {
        cout << table[i][j] << " ";
    }
    cout << endl;
}

for (int i=1; i <= n; i++) {
    cout << "susedi na " << i << ": ";
    for (int j=0; j < nbs[i].size(); j++) {
        cout << nbs[i][j] << " ";
    }
    cout << endl;
}**/

for (int i=0; i < 5003; i++) {used[i] = false; level[i] = -1;}

level[1] = 0;
dfs (1);

//cout << min_cycle << " " << min_pseudo << endl;

for (int i=1; i <= n; i++) {
    if (found4 == true) {break;}
    if (found4 and (found5 == true or found3==true)) {break;}
    vector <int> v;
    v.push_back(i);
    cycle(v);
}

//cout << found4 << " " << found5 << " " << found3 << endl;

int answer = inf;

if (min_cycle == inf and found3 == false and found4 == false and found5 == false) {cout << -1 << endl; return 0;}
if (found4 == true) {cout << 2 << endl; return 0;}
if (found3 == true or found5 == true) {cout << 3 << endl; return 0;}
cout << 4 << endl;

return 0;
}