#include <bits/stdc++.h>
using namespace std;

int n;
char c;
int table[5003][5003];
vector <int> nbs[5003];
bool used[5003];
int level[5003];
bool found_pone_4 = false, found_3=false, found_4=false, found_5=false;

void dfs (int curr) {
    used[curr] = true;
    if (found_pone_4 == true) {return;}
    for (int i=0; i < nbs[curr].size(); i++) {
        int currn = nbs[curr][i];
        if (used[currn] == true) {
            if (abs(level[currn] - level[curr]) >= 3) {
                found_pone_4 = true;
                return;
            }
        }
        else {
            level[currn] = level[curr] + 1;
            dfs(currn);
            used[currn] = false;
            level[currn] = -1;
        }
    }
    used[curr] = false;
    level[curr] = -1;
}

void cycle3 (vector <int> dosega) {
    if (found_3 == true) {return;}
    if (dosega.size() == 3) {
        if (table[dosega[2]][dosega[0]] == 1) {
            if (nbs[dosega[2]].size() > 2 or nbs[dosega[1]].size() > 2 or nbs[dosega[0]].size() > 2) {
                found_3 = true;
                return;
            }
        }
    }
    else {
        int curr = dosega[dosega.size()-1];
        for (int i=0; i < nbs[curr].size(); i++) {
            int currn = nbs[curr][i];
            bool k1 = false;
            for (int j=0; j < dosega.size(); j++) {
                if (currn == dosega[j]) {k1 = true; break;}
            }
            if (k1 == true) {continue;}
            dosega.push_back(currn);
            cycle3(dosega);
            dosega.pop_back();
        }
    }
}

void cycle4 (vector <int> dosega) {
    if (found_4 == true) {return;}
    if (dosega.size() == 4) {
        if (table[dosega[3]][dosega[0]] == 1) {
            found_4 = true;
            return;
        }
    }
    else {
        int curr = dosega[dosega.size()-1];
        for (int i=0; i < nbs[curr].size(); i++) {
            int currn = nbs[curr][i];
            bool k1 = false;
            for (int j=0; j < dosega.size(); j++) {
                if (currn == dosega[j]) {k1 = true; break;}
            }
            if (k1 == true) {continue;}
            dosega.push_back(currn);
            cycle4(dosega);
            dosega.pop_back();
        }
    }
}

void cycle5 (vector <int> dosega) {
    if (found_5 == true) {return;}
    if (dosega.size() == 5) {
        if (table[dosega[4]][dosega[0]] == 1) {
            found_5 = true;
            return;
        }
    }
    else {
        int curr = dosega[dosega.size()-1];
        for (int i=0; i < nbs[curr].size(); i++) {
            int currn = nbs[curr][i];
            bool k1 = false;
            for (int j=0; j < dosega.size(); j++) {
                if (currn == dosega[j]) {k1 = true; break;}
            }
            if (k1 == true) {continue;}
            dosega.push_back(currn);
            cycle5(dosega);
            dosega.pop_back();
        }
    }
}

int main () {
ios_base::sync_with_stdio(false);
cin.tie(0); cout.tie(0);

cin >> n;

for (int i=1; i <= n-1; i++) {
    for (int j=i+1; j <= n; j++) {
        cin >> c;
        if (c == '1') {
            nbs[i].push_back(j);
            nbs[j].push_back(i);
            table[i][j] = 1; table[j][i] = 1;
        }
    }
}

for (int i=1; i <= n; i++) {level[i] = -1; used[i] = false;}

level[1] = 0;
dfs(1);

for (int i=1; i <= n; i++) {
    if (found_3 == true) {break;}
    vector <int> v;
    v.push_back(i);
    cycle3(v);
}

if (found_pone_4 == false and found_3 == false) {cout << -1 << endl; return 0;}
return 0;

for (int i=1; i <= n; i++) {
    if (found_4 == true) {break;}
    vector <int> v;
    v.push_back(i);
    cycle4(v);
}

for (int i=1; i <= n; i++) {
    if (found_5 == true) {break;}
    vector <int> v;
    v.push_back(i);
    cycle5(v);
}

//cout << found_4 << " " << found_5 << endl;

if (found_4 == true) {cout << 2 << endl; return 0;}
if (found_5 == true or found_3 == true) {cout << 3 << endl; return 0;}
cout << 4 << endl;

return 0;
}
