#include <bits/stdc++.h>
using namespace std;

int n;
char c;
int table[5003][5003];
vector <int> nbs[5003];
int min_path[5003][5003];
const int inf = 1000000000;

int main () {
ios_base::sync_with_stdio(false);
cin.tie(0); cout.tie(0);

cin >> n;

for (int i=1; i <= n-1; i++) {
    for (int j=i+1; j <= n; j++) {
        cin >> c;
        if (c == '1') {
            nbs[i].push_back(j);
            nbs[j].push_back(i);
            table[i][j] = 1; table[j][i] = 1;
        }
    }
}

for (int i=1; i <= n; i++) {
    for (int j=1; j <= n; j++) {
        if (i == j) {min_path[i][j] = 0; continue;}
        if (table[i][j] == 0) {
            min_path[i][j] = inf;
            min_path[j][i] = inf;
        }
        else {
            min_path[i][j] = 1;
            min_path[j][i] = 1;
        }
    }
}

for (int k=1; k <= n; k++) {
    for (int i=1; i <= n; i++) {
        for (int j=1; j <= n; j++) {
            if (min_path[i][k] + min_path[k][j] < min_path[i][j]) {
                min_path[i][j] = min_path[i][k] + min_path[k][j];
                min_path[j][i] = min_path[i][k] + min_path[k][j];
                //cout << i << " to " << j << " is now " << min_path[i][j] << " thanks to " << k << endl;
            }
        }
    }
}

/**for (int i=1; i <= n; i++) {
    for (int j=1; j <= n; j++) {
        cout << min_path[i][j] << " ";
    }
    cout << endl;
}**/

int ans=inf;

for (int i=1; i <= n; i++) {
    for (int j=1; j <= n; j++) {
        for (int z=1; z <= n; z++) {
            for (int t=1; t <= n; t++) {
                if (i == z or j == t or i == j or i == t or j==z or z==t) {continue;}
                if (min_path[i][j] == 1 and min_path[z][t] == 1) {
                    ans = min (ans, min_path[z][j] + min_path[i][t]);
                }
            }
        }
    }
}

if (ans == inf) {cout << -1 << endl;}
else {cout << ans << endl;}

return 0;
}