#include <iostream>
#define MAX_N 5000
using namespace std;

int table[MAX_N][MAX_N];
long long n, m;
string outlay[MAX_N];
long long currsum;

bool check(int i, int j, int t)
{
    if(table[i][j]!=0 || outlay[i-1][j-1]=='#')
    {
        return false;
    }
    if(i-t>=1 && table[i-t][j]!=0 && table[i-t][j]!=t)
    {
        return true;
    }
    if(i+t<=n && table[i+t][j]!=0 && table[i+t][j]!=t)
    {
        return true;
    }
    if(j-t>=1 && table[i][j-t]!=0 && table[i][j-t]!=t)
    {
        return true;
    }
    if(j+t>=m && table[i][j+t]!=0 && table[i][j+t]!=t)
    {
        return true;
    }
    return false;
}


void fill_table(int t)
{
    currsum+=t;
    for(int i=1; i<=min(currsum, n); i++)
    {
        for(int j=1; j<=min(currsum, m); j++)
        {
            //cout << i  << " " << j << " " << t << endl;
            if(check(i, j, t))
            {
                table[i][j]=t;
            }
        }
    }
}

int main()
{
    cin >> n >> m;

    for(int i=0; i<n; i++)
    {
        cin >> outlay[i];
    }
    table[1][1]=-1;
    currsum=1;
    for(int i=1; i<=m+n; i++)
    {
        fill_table(i);
        /*for(int j=1; j<=n; j++)
        {
            for(int k=1; k<=m; k++)
            {
                cout << table[j][k] << " ";
            }
            cout << endl;
        }*/
        if(table[n][m]!=0)
        {
            break;
        }
    }


    /*for(int j=1; j<=n; j++)
    {
        for(int k=1; k<=m; k++)
        {
            cout << table[j][k] << " ";
        }
        cout << endl;
    }*/

    if(table[n][m]==0)
    {
        cout << -1;
    }
    else
    {
        cout << table[n][m];
    }


    return 0;
}
