#include <iostream>
#define MAX_N 5005
using namespace std;

int table[MAX_N][MAX_N];
long long n, m;
string outlay[MAX_N];
long long currsum;

bool check(int i, int j, int t)
{
    if(table[i][j]!=0 || outlay[i][j]=='#')
    {
        return false;
    }
    if(i-t>=0 && table[i-t][j]!=0 && table[i-t][j]!=t)
    {
        //cout << "#1" << i << " " << j << " " << t << endl;
        return true;
    }
    if(i+t<n && table[i+t][j]!=0 && table[i+t][j]!=t)
    {
        //cout << "#2" << i << " " << j << " " << t << endl;
        return true;
    }
    if(j-t>=0 && table[i][j-t]!=0 && table[i][j-t]!=t)
    {
        //cout << "#3" << i << " " << j << " " << t << endl;
        return true;
    }
    if(j+t>m && table[i][j+t]!=0 && table[i][j+t]!=t)
    {
        //cout << "#4" << i << " " << j << " " << t << endl;
        return true;
    }
    return false;
}


void fill_table(int t)
{
    currsum+=t;
    for(int i=0; i<n; i++)
    {
        for(int j=0; j<m; j++)
        {
            //cout << i  << " " << j << " " << t << endl;
            if(check(i, j, t))
            {
                table[i][j]=t;
            }
        }
    }
}

int main()
{
    cin >> n >> m;

    for(int i=0; i<n; i++)
    {
        cin >> outlay[i];
    }
    for(int i=0; i<n; i++)
    {
        for(int j=0; j<n; j++)
        {
            table[i][j]=0;
        }
    }
    table[0][0]=-1;
    currsum=1;
    for(int i=1; i<=n+m; i++)
    {
        fill_table(i);
        /*for(int j=1; j<=n; j++)
        {
            for(int k=1; k<=m; k++)
            {
                cout << table[j][k] << " ";
            }
            cout << endl;
        }*/
        if(table[n-1][m-1]!=0)
        {
            break;
        }
    }


    /*for(int j=0; j<n; j++)
    {
        for(int k=0; k<m; k++)
        {
            cout << table[j][k] << " ";
        }
        cout << endl;
    }*/

    if(table[n-1][m-1]==0)
    {
        cout << -1;
    }
    else if(n==1 && m==1)
    {
        cout << 0;
    }
    else
    {
        cout << table[n-1][m-1];
    }


    return 0;
}
