#include <iostream>
#define MAX_N 5005
using namespace std;

int table[MAX_N][MAX_N];
string input[MAX_N];
int n, m;
int currsum;

bool check(int i, int j, int t)
{
    if(table[i][j]!=0 || input[i][j]=='#')
    {
        return false;
    }
    else if(i-t>=0 && table[i-t][j]!=0 && table[i-t][j]!=t)
    {
        return true;
    }
    else if(i+t<n && table[i+t][j]!=0 && table[i+t][j]!=t)
    {
        return true;
    }
    else if(j-t>=0 && table[i][j-t]!=0 && table[i][j-t]!=t)
    {
        return true;
    }
    else if(j+t<m && table[i][j+t]!=0 && table[i][j+1]!=t)
    {
        return true;
    }
    return false;
}


void fill_table(int t)
{
    currsum+=t;

    for(int i=0; i<min(currsum, n); i++)
    {
        for(int j=0; j<min(currsum, m); j++)
        {
            if(check(i, j, t))
            {
                table[i][j]=t;
            }
        }
    }
}

int main()
{
    cin >> n >> m;

    for(int i=0; i<n; i++)
    {
        cin >> input[i];
    }


    table[0][0]=-1;

    for(int i=1; i<=5000; i++)
    {
        fill_table(i);
        if(table[n-1][m-1]!=0)
        {
            break;
        }
    }
    if(table[n-1][m-1]!=0)
    {
        cout << table[n-1][m-1];
    }
    else
    {
        cout << -1;
    }





    return 0;
}
