#include <bits/stdc++.h>
#pragma optimize GCC ("Ofast")
#define endl '\n'
using namespace std;

const int maxn = 2048;
int n, m, dp[maxn][maxn];
int i, j, pri, prj;
bool a[maxn][maxn];

void read()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);

    cin >> n >> m ;
    char c;
    for (i=1; i<=n; ++i)
    {
        for (j=1; j<=m; ++j)
        {
            cin >> c;
            if (c == '#')
                a[i][j] = true;
        }
    }
}

void path(int&timer)
{
    for (i=1; i<=n; ++i)
    {
        for (j=1; j<=m; ++j)
        {
            if (a[i][j] || dp[i][j]) continue;
            pri = i + timer;
            prj = j;
            if (pri <= n && dp[pri][prj] && dp[pri][prj] != timer)
                dp[i][j] = timer;

            pri = i - timer;
            if (pri > 0 && ((pri == 1 && prj == 1) || dp[pri][prj] && dp[pri][prj] != timer))
                dp[i][j] = timer;

            pri = i;
            prj = j + timer;
            if (prj <= m && dp[pri][prj] && dp[pri][prj] != timer)
                dp[i][j] = timer;

            prj = j - timer;
            if (prj > 0 && ((pri == 1 && prj == 1) || dp[pri][prj] && dp[pri][prj] != timer))
                dp[i][j] = timer;
        }
    }

    if (dp[n][m])
    {
        cout << dp[n][m] << '\n' ;
        exit(0);
    }
}

void solve()
{
    dp[1][1] = 0;
    int timer = 1;
    while (timer < 4040)
    {
        path(timer);
        ++ timer;
    }
    cout << "-1" << '\n';
}

int main()
{
    read();
    solve();
    return 0;
}