#include <bits/stdc++.h>
#include "crption.h"
using namespace std;

const int maxn = 1e5+2;
vector <int> v[maxn];
pair <int, int> d[maxn];
bool beg[maxn], used[maxn];

void dfs(int ver)
{
    used[ver] = true;
    int i, len = v[ver].size(), nb;
    for (i=0; i<len; ++i)
    {
        d[v[ver][i]].first += d[ver].first;
        if (!used[i])
            dfs[v[ver][i]];
    }
}

vector<int> solve(const int &n, const vector<int> &from, const vector<int> &to)
{
    memset(beg, 1, sizeof(beg));
    int m = from.size(), i;
    for (i=0; i<m; ++i)
    {
        bool k = check(from[i], to[i]);
        if (k)
        {
            v[to[i]].push_back(from[i]);
            beg[from[i]] = false;
        }
        else
        {
            v[from[i]].push_back(to[i]);
            beg[to[i]] = false;
        }
    }


    for (i=0; i<n; ++i)
    {
        d[i].second = i;
        if (beg[i])
        {
            d[i].first = 1;
            memset(used, 0, sizeof(used));
            dfs(i);
        }
    }
    sort(d, d+n);

    vector <int> ans(n);
    for (i=0; i<n; ++i)
        ans[i] = d[i].second;
    return ans;
}
