#include<iostream>
#define endl "\n"
using namespace std;

long long const MAXN=5001;
long long n, m, a[MAXN][MAXN], dp[MAXN][MAXN], inf = 1e18+7;
char ch;

void recursion(long long i, long long j, long long k)
{
    if(j-k >= 1 && a[i][j-k] == 0)
    {
        if(dp[i][j-k] > k)
        {
            dp[i][j-k] = k;
            for(long long k1=k+1; k1<=max(n,m); k1++)
            {
                if(j+1 <= m && a[i][j+1] == 0)
                {
                    if(dp[i][j+1] > k)
                    {
                        dp[i][j+1] = k;
                        recursion(i, j+1, k+1);
                    }
                }
                if(i+1 <= n && a[i+1][j] == 0)
                {
                    if(dp[i+1][j] > k)
                    {
                        dp[i+1][j] = k;
                        recursion(i+1, j, k+1);
                    }
                }
            }
            recursion(i, j-k, k+1);
        }
    }
    if(i-k >= 1 && a[i-k][j] == 0)
    {
        if(dp[i-k][j] > k)
        {
            dp[i-k][j] = k;
            for(long long k1=k+1; k1<=max(n,m); k1++)
            {
                if(j+1 <= m && a[i][j+1] == 0)
                {
                    if(dp[i][j+1] > k)
                    {
                        dp[i][j+1] = k;
                        recursion(i, j+1, k+1);
                    }
                }
                if(i+1 <= n && a[i+1][j] == 0)
                {
                    if(dp[i+1][j] > k)
                    {
                        dp[i+1][j] = k;
                        recursion(i+1, j, k+1);
                    }
                }
            }
            recursion(i-k, j, k+1);
        }
    }
    if(j+k <= m && a[i][j+k] == 0)
    {
        if(dp[i][j+k] > k)
        {
            dp[i][j+k] = k;
            recursion(i, j+k, k+1);
        }
    }
    if(i+k <= n && a[i+k][j] == 0)
    {
        if(dp[i+k][j] > k)
        {
            dp[i+k][j] = k;
            recursion(i+k, j, k+1);
        }
    }
}

void read()
{
    cin>>n>>m;
    for(long long i=1; i<=n; i++)
    {
        for(long long j=1; j<=m; j++)
        {
            cin>>ch;
            if(ch == '#') a[i][j] = 1;
        }
    }
    for(long long i=1; i<MAXN; i++)
    {
        for(long long j=1; j<MAXN; j++)
        {
            dp[i][j] = inf;
        }
    }
    dp[1][1] = 0;
    for(long long i=1; i<=n; i++)
    {
        for(long long j=1; j<=m; j++)
        {
            for(long long k=dp[i][j]+1; k<=max(n, m); k++)
            {
                recursion(i, j, k);
            }
        }
    }
    if(dp[n][m] == inf) cout<<-1<<endl;
    else cout<<dp[n][m]<<endl;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    read();
    return 0;
}
