#include<iostream>
#include<vector>
#include<queue>
#include<algorithm>
#define endl "\n"
using namespace std;

int const MAXN=551;
int n, d[MAXN][MAXN], inf = 1e9+7, cnt, a[MAXN][MAXN];
vector<int> v[MAXN];
string s;

struct edge
{
    int x, y, dist;
};

vector<edge> p;

void BFS(int i)
{
    queue<int> q;
    q.push(i);
    while(!q.empty())
    {
        int w = q.front();
        q.pop();
        int sz = v[w].size();
        for(int j=0; j<sz; j++)
        {
            int nb = v[w][j];
            if(!d[i][nb])
            {
                cnt++;
                d[i][nb] = d[i][w]+1;
                if(i != nb) p.push_back({i, nb, d[i][nb]});
                q.push(nb);
            }
        }
    }
}

bool cmp(edge i, edge j)
{
    return i.dist < j.dist;
}

void read()
{
    cin>>n;
    for(int i=1; i<n; i++)
    {
        cin>>s;
        for(int j=i+1; j<=n; j++)
        {
            a[i][j] = s[j-i-1] - '0';
            a[j][i] = s[j-i-1] - '0';
            if(s[j-i-1] - '0' == 1)
            {
                v[i].push_back(j);
                v[j].push_back(i);
            }
        }
    }
    int max_comp = 0;
    for(int i=1; i<=n; i++)
    {
        BFS(i);
        max_comp = max(max_comp, cnt);
        cnt = 0;
    }
    if(max_comp < 4)
    {
        cout<<-1<<endl;
        return;
    }
    sort(p.begin(), p.end(), cmp);
    int ans = inf, r = p.size();
    for(int i=0; i<p.size(); i++)
    {
        for(int j=i+1; j<r; j++)
        {
            if(p[i].x != p[j].x && p[i].x != p[j].y && p[i].y != p[j].x && p[i].y != p[j].y)
            {
                if((a[p[i].x][p[j].x] == 1 && a[p[i].y][p[j].y]) || (a[p[i].x][p[j].y] && a[p[i].y][p[j].x]))
                {
                    ans = min(ans, p[i].dist + p[j].dist);
                    r = j;
                    break;
                }
            }

        }
    }
    cout<<ans<<endl;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    read();
    return 0;
}
