#include <bits/stdc++.h>
using namespace std;
const long long maxn = 5005;
long long n,m;
long long a[maxn][maxn];
long long dp[maxn][maxn];

struct cell
{
    int x;
    int y;
    int p;

    cell() {};
    cell( int x1, int y1, int p1 )
    {
        x = x1;
        y = y1;
        p = p1;
    }
};
void read()
{
    cin >> n >> m;
    for( int i = 1; i <= n; i ++ )
    {
        for( int j = 1; j <= m; j ++ )
        {
            char c;
            cin >> c;
            if( c == '#' ) a[i][j] = 1;
        }
    }
}

void solve()
{
    memset(dp,-1,sizeof(dp));
    dp[1][1] = 0;

    queue<cell>q;
    q.push( cell(1,1,0) );

    while( !q.empty() )
    {
        cell w = q.front();
        q.pop();

        int t = w.p;
        int i = w.x;
        int j = w.y;

        //cout << i << " "<< j << endl;
        //cout << t << " " << dp[i][j] << endl;

        if( t <= dp[i][j] )
        {

            //cout << i << " " << j << " " << t << endl;

            for( int k = t + 1; k <= n; k ++ )
            {
                if( i + k > n ) break;
                if( a[i+k][j] == 1 ) continue;

                if( dp[i+k][j] == -1 || dp[i+k][j] > k )
                {
                    dp[i+k][j] = k;
                    q.push( cell(i+k,j,dp[i+k][j]) );
                }
            }

            for( int k = t + 1; k <= m; k ++ )
            {
                if( j + k > m ) break;
                if( a[i][j+k] == 1 ) continue;

                if( dp[i][j+k] == -1 || dp[i][j+k] > k )
                {
                    dp[i][j+k] = k;
                    q.push( cell(i,j+k,dp[i][j+k]) );
                }
            }


            for( int k = t + 1; k <= n; k ++ )
            {
                if( i-k < 1 ) break;
                if( a[i-k][j] == 1 ) continue;

                if( dp[i-k][j] == -1 || dp[i-k][j] > k )
                {
                    dp[i-k][j] = k;
                    q.push( cell(i-k,j,dp[i-k][j]) );
                }
            }

            for( int k = t + 1; k <= m; k ++ )
            {
                if( j - k < 1 ) break;
                if( a[i][j-k] == 1 ) continue;

                if( dp[i][j-k] == -1 || dp[i][j-k] > k )
                {
                    dp[i][j-k] = k;
                    q.push( cell(i,j-k,dp[i][j-k]) );
                }
            }

        }
    }

    cout << dp[n][m] << endl;
}
int main()
{
    read();
    solve();
    return 0;
}
