#include <bits/stdc++.h>
#include "crption.h"
using namespace std;

const int maxn = 100001;
vector<int>v[maxn];
vector<int>v1[maxn];
int used[maxn];
int h[maxn];

void dfs( int w )
{
    used[w] = 1;
    int sz = v[w].size();

    for( int i = 0; i < sz; i ++ )
    {
        int nb = v[w][i];
        if( used[nb] == 0 )
        {
            h[nb] = h[w] + 1;
            dfs(nb);
        }
    }

    int sz1 = v1[w].size();
    for( int i = 0; i < sz1; i ++ )
    {
        int nb = v1[w][i];
        if( used[nb] == 0 )
        {
            h[nb] = h[w] - 1;
            dfs(nb);
        }
    }
}

void dfs1( int w )
{
    used[w] = 1;
    int sz = v1[w].size();

    for( int i = 0; i < sz; i ++ )
    {
        int nb = v1[w][i];
        if( used[nb] == 0 )
        {
            h[nb] = h[w] - 1;
            dfs1(nb);
        }
    }
}

vector <int> solve (const int &N, const vector <int> &from, const vector<int> &to)
{
    int m1 = from.size();

    for( int i = 0; i < m1; i ++ )
    {
        int x = from[i];
        int y = to[i];

        int lamp = check(x,y);
        if( lamp == 1 )
        {
            v[y].push_back(x);
            v1[x].push_back(y);
        }
        else
        {
            v[x].push_back(y);
            v1[y].push_back(x);
        }
    }

    h[0] = N + 1;
    dfs(0);

   /*
    for( int i = 0; i < N; i ++ )
    {
        if( v1[i].size() == 0 )
        {
            h[i] = 1;
            dfs(i);
        }
    }
    */

    vector< pair<int,int> >ans;
    for( int i = 0; i < N; i ++ )
    {
        ans.push_back( pair<int,int>(h[i],i) );
    }

    sort(ans.begin(),ans.end());
    vector<int>red;

    //cout << endl;
    for( int i = 0; i < N; i ++ )
    {
        int nb = ans[i].second;
        red.push_back(nb);
        //cout << nb << " "<< h[nb] << endl;
    }
    //cout << endl;

    return red;
}
