#include<bits/stdc++.h>
using namespace std;
const int maxn = 1e6+10;
struct Node{
    int ver;
    int x, y, g, h;
    Node(){}
    Node(int _ver, int _x, int _y){
        ver = _ver;
        x = _x;
        y = _y;
        g = 0;
        h = 0;
    }
    Node (int _ver, int _x, int _y, int _g,int _h){
        ver = _ver;
        x = _x;
        y = _y;
        g = _g;
        h = _h;
    }
    bool operator<(const Node &other)const{
        return g + h > other.g + other.h;
    }
};
int n, m;
string table[maxn];
vector<Node>v[maxn];///nb of ver
int cntofNodes = 1;
void read(){
    cin >> n >> m;
    for (int i = 1;i <= n; ++i)
        cin >> table[i];
}
void init_graph(){
    queue <Node>q;
    q.push(Node(1, 1, 1));
    cntofNodes++;
    Node cur;
    while(!q.empty()){
        cur = q.front();
        q.pop();
        //cout << cur.ver << " " << cur.x << " " << cur.y << endl;
        int i = cur.x, j = cur.y - 1;
        for (int k = i+1; k <= n;/* cout << table[k][j]<<" ",*/ ++k)
            if (table[k][j] == '.'){
                //cout << "to push: "<< cntofNodes<< " "<< k << " " << cur.y <<endl;
                v[cur.ver].push_back(Node(cntofNodes, k, cur.y, k-cur.x, 0));
                q.push(Node(cntofNodes, k, cur.y));
                cntofNodes++;
                break;
            }
        //cout << endl;
        for (int k = cur.y; k < m;/*cout << table[k][j]<<" ",*/ ++k)
            if (table[i][k] == '.'){
                //cout << "to push: "<< cntofNodes<< " "<< cur.x << " " << k+1<<endl;
                v[cur.ver].push_back(Node(cntofNodes, cur.x, k + 1, k-cur.y + 1, 0));
                q.push(Node(cntofNodes, cur.x, k + 1));
                cntofNodes++;
                break;
            }
    }
}
void print_graph(){
    queue<int>q;
    q.push(1);
    while(!q.empty()){
        int w = q.front();
        q.pop();
        cout << w << ":\n";
        for (auto i:v[w]){
            cout << i.ver<< " "<< i.x << " " << i.y << endl;
            q.push(i.ver);
        }

    }
}
int heuristic(pair<int,int> cell){
    int dx = n - cell.first;
    int dy = m - cell.second;
    return sqrt(dx * dx + dy * dy);
}
void Astar(){
    unordered_set<int>used;
    priority_queue<Node> q;
    Node cur(1, 1, 1, 0, 0);
    q.push(cur);
    while (!q.empty()){
        cur = q.top();
        q.pop();
        if (cur.x == n && cur.y == m)
            break;
        if (used.find(cur.ver) == used.end()){
            used.insert(cur.ver);
            for (auto i:v[cur.ver]){
                Node nb = i;
                //nb.h = heuristic({nb.x, nb.y});
                nb.g = cur.g + 1;
                q.push(nb);
            }
        }
    }
    if (cur.x == n && cur.y == m)
        cout << cur.g << endl;
    else cout << "-1\n" ;
}
int main(){
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    read();
    init_graph();
    //print_graph();
    Astar();
    return 0;
}
