#include<bits/stdc++.h>
using namespace std;
const int maxn = 5010, inf = 1e9+7;
const unsigned int dinf = (int) -1;
vector<int> v[maxn];
int n;
unsigned int dist[maxn][maxn];
bool used[maxn];
void read(){
    cin >> n;
    for(int i = 1; i < n; ++i){
        string s;
        cin >> s;
        for (int j = 0; j < s.size(); ++j)
            if (s[j] == '1'){
                v[i].push_back(i+j+1);
                v[i+j+1].push_back(i);
            }
    }
}
void calcdist(){
    memset(dist, -1, sizeof(dist));
    for (int i = 1; i <= n; ++i){
        memset(used, 0, sizeof(used));
        used[i] = 1;
        dist[i][i]=0;
        queue<int>q;
        q.push(i);
        while(!q.empty()){
            int ver = q.front();
            q.pop();
            for (auto cur:v[ver]){
                int nb = cur;
                if (!used[nb]){
                    used[nb] = 1;
                    dist[i][nb]=min(dist[i][ver]+1, dist[i][nb]);
                    q.push(nb);
                }
            }
        }
    }
    /*for (int i = 1;i <=n;++i, cout << endl)
        for (int j = 1; j <=n;++j)
        cout<<dist[i][j]<<" ";*/
}
void find_intresting(){
    unsigned int ans = dinf;
    for (int u1 = 1; u1 <= n; ++u1){
        for (int v1 = u1 + 1; v1 <= n; v1++){
            for (int u2 = v1 + 1; u2 <= n;  u2 ++){
                for (int v2 = u2 + 1; v2 <= n; v2++){
                    if (dist[u1][v1] == 1 && dist[u2][v2] == 1){
                        if (dist[u1][u2] != dinf && dist[v1][v2] != inf){
                            ans = min(ans, dist[u1][u2] + dist [v1][v2]);
                        }
                    }
                }
            }
        }
    }
    cout <<(int)ans<<endl;
}
int main(){
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    read();
    calcdist();
    find_intresting();
    return 0;
}
