#include<bits/stdc++.h>
#define endl '\n'

using namespace std;

struct edge
{
    int v, pos, dist;
    edge() {}
    edge(int a, int b, int c)
    {
        v=a;
        pos=b;
        dist=c;
    }
};

bool operator<(edge p, edge q)
{
    return p.dist>q.dist;
}

int n, m;
string s[1000005];
vector<vector<int> > dist[4];
vector<vector<int> > dp[4];
bool used[4][1000005];
priority_queue<edge> pq;

void Dijkstra()
{
    dist[0][0][0]=0;
    dist[1][0][0]=0;
    dist[2][0][0]=0;
    dist[3][0][0]=0;
    pq.push(edge(0, 0, 0));
    pq.push(edge(0, 1, 0));
    pq.push(edge(0, 2, 0));
    pq.push(edge(0, 3, 0));

    while(!pq.empty())
    {
        edge tedg=pq.top();
        pq.pop();
        int tv=tedg.v, tdist=tedg.dist, pos=tedg.pos;
        if(used[pos][tv]) continue;
        used[pos][tv]=1;
        int x=tv/m, y=tv%m;
       ///cout<<x<<" "<<y<<" "<<tdist<<endl;
        if(pos==0 && y!=m-1)
        {
            if(tdist+1<dist[0][x][y+1])
            {
                dist[0][x][y+1]=tdist+1;
                pq.push(edge(x*m+y+1, 0, tdist+1));
            }
        }
        if(pos==1 && y!=0)
        {
            if(tdist+1<dist[1][x][y-1])
            {
                dist[1][x][y-1]=tdist+1;
                pq.push(edge(x*m+y-1, 1, tdist+1));
            }

        }
        if(pos==2 && x!=n-1)
        {
            if(tdist+1<dist[2][x+1][y])
            {
                dist[2][x+1][y]=tdist+1;
                pq.push(edge((x+1)*m+y, 2, tdist+1));
            }
        }
        if(pos==3 && x!=0)
        {
            if(tdist+1<dist[3][x-1][y])
            {
                dist[3][x-1][y]=tdist+1;
                pq.push(edge((x-1)*m+y, 3, tdist+1));
            }
        }
        if(s[x][y]=='#') continue;
        if(y+tdist+1<m)
        {
            if(tdist+1<dist[0][x][y+tdist+1])
            {
                dist[0][x][y+tdist+1]=tdist+1;
                pq.push(edge(x*m+y+tdist+1, 0, tdist+1));
            }
        }
        if(y-tdist-1>=0)
        {
            if(tdist+1<dist[1][x][y-tdist-1])
            {
                dist[1][x][y-tdist-1]=tdist+1;
                pq.push(edge(x*m+y-tdist-1, 1, tdist+1));
            }
        }
        if(x+tdist+1<n)
        {
            if(tdist+1<dist[2][x+tdist+1][y])
            {
                dist[2][x+tdist+1][y]=tdist+1;
                pq.push(edge((x+tdist+1)*m+y, 2, tdist+1));
            }
        }
        if(x-tdist-1>=0)
        {
            if(tdist+1<dist[3][x-tdist-1][y])
            {
                dist[3][x-tdist-1][y]=tdist+1;
                pq.push(edge((x-tdist-1)*m+y, 3, tdist+1));
            }
        }
    }

}

int main()
{
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    cin>>n>>m;
    dist[0].resize(n+1);
    dist[1].resize(n+1);
    dist[2].resize(n+1);
    dist[3].resize(n+1);
    for(int i=0; i<n; i++)
    {
        dist[0][i].resize(m+1, 1e7);
        dist[1][i].resize(m+1, 1e7);
        dist[2][i].resize(m+1, 1e7);
        dist[3][i].resize(m+1, 1e7);
        cin>>s[i];
    }/**
    for(int i=0; i<n; i++)
    {
        for(int j=0; j<m; j++) cout<<dp[3][i][j]<<" ";
        cout<<endl;
    }*/
    Dijkstra();
    int ans=min(dist[0][n-1][m-1], dist[2][n-1][m-1]);
    if(ans==1e7) cout<<-1<<endl;
    else cout<<ans<<endl;
    return 0;
}
/**
8 6
..####
######
#.###.
#.###.
#.###.
#.###.
#.###.
#####.
*/