#include <bits/stdc++.h>
#include "crption.h"
using namespace std;

const int MAXN = 1e5 + 5;
vector <int> G[MAXN];

vector <int> ans;

bool used[MAXN];
void dfs(int x)
{
    if (used[x]) return;
    used[x] = 1;

    ans.push_back(x);

    for (int i = 0; i < G[x].size(); i++)
        dfs(G[x][i]);
}

vector<int> solve(const int &n, const vector<int> &from, const vector<int> &to)
{
    vector <pair<int,int>> v;
    for (int i = 0; i < from.size(); i++)
        v.push_back({from[i], to[i]});

    for (int i = 0; i < v.size(); i++)
    {
        if (check(v[i].first, v[i].second))
        {
            swap(v[i].first, v[i].second);
            // K++;
        }
    }

//    sort(v.begin(), v.end());

    for (int i = 0; i < v.size(); i++)
    {
        G[v[i].first].push_back(v[i].second);
    }

    dfs(v[0].first);

    for (int i = 0; i < n; i++)
        if (!used[i]) ans.push_back(i);

    return ans;
}

