#include <bits/stdc++.h>

typedef long long ll;
typedef long double ld;

const int MAX_N = 1e4 + 42;
const int mod = 1e9 + 7;
const int INF = 1e9;

int dist[MAX_N][MAX_N];

std::vector<int> v[MAX_N];
bool viz[MAX_N];

std::vector<std::pair<int, int>> edg;

int main (){

    std::ios_base::sync_with_stdio(false); std::cin.tie(NULL);

    int n;
    std::cin>>n;
    for( int i=0 ; i<n-1 ; i++ ){
        std::string curr;
        std::cin>>curr;
        for( int j=0 ; j<n-i-1 ; j++ ){
            if( curr[j] == '1' ){
                edg.push_back({i, i+j+1});
                v[i].push_back(i+j+1);
                v[i+j+1].push_back(i);
            }
        }
    }
   // std::memset(dist, INF, sizeof(dist));
    for( int i=0 ; i<n ; i++ ){
        for( int j=0 ; j<n ; j++ ) dist[i][j] = INF;
        std::queue<int> q;
        q.push(i);
        dist[i][i] = 0;
        while( !q.empty() ){
            int curr = q.front();
            q.pop();
            viz[curr] = true;
            for( auto j : v[curr] ){
                if( !viz[j] ){
                    dist[i][j] = dist[i][curr] + 1;
                    q.push(j);
                    viz[j] = true;
                }
            }
        }
        /*
        std::cerr<<" dist = "<<i<<"\n";
        for( int j=0 ; j<n ; j++ ){
            std::cerr<<dist[i][j]<<" ";
        }
        std::cerr<<"\n";
        */
        for( int i=0 ; i<n ; i++ ) viz[i] = false;
    }

    ll nas = INF;
    for( int i=0 ; i<edg.size() ; i++ ){
        for( int j=i+1 ; j<edg.size() ; j++ ){
            int a = edg[i].first;
            int b = edg[i].second;

            int a1 = edg[j].first;
            int b1 = edg[j].second;

       //     std::cerr<<a<<" "<<b<<" -> "<<a1<<" "<<b1<<"\n";

            if( a == a1 or a == b1 ) continue;
            if( b == a1 or b == b1 ) continue;
            if( a == b or a1 == b1 ) continue;
            if( dist[a][a1] == INF ) continue;
            if( dist[b][b1] == INF ) continue;

            ll currNas1 = dist[a][a1] + dist[b][b1];
            ll currNas2 = dist[a][b1] + dist[b][a1];
            nas = std::min( nas, std::min( currNas1, currNas2 ) );
        }
    }

    if( nas == INF ) std::cout<<"-1\n";
    else std::cout<<nas<<"\n";

    return 0;
}
/*
6                                                                                                                       11000                                                                                                                   1001                                                                                                                    100                                                                                                                     10                                                                                                                      1
*/
