//#include <bits/stdc++.h>
#include <iostream>
#include <vector>
#include <queue>
using namespace std;
const int MAXN = 5001;
struct Vertex{
    int ind;
    int prev;
    int step;
};
vector<int> neighbours[MAXN];
int step[MAXN];
bool walked[MAXN];
int walk(int curr, int prev, int minn) {
    if (step[curr] > minn) {
        return MAXN;
    }
    if (step[curr] > -1) {
        if (step[prev] + 1 - step[curr] > 3) {
            return step[prev] + 1 - step[curr] - 2;
        } else {
            if (neighbours[curr].size() == 2) {
                for (auto it : neighbours[curr]) {
                    if (neighbours[it].size() > 2) {
                        return 3;
                    }
                }
                return MAXN;
            } else {
                return 3;
            }
        }
    }
    step[curr] = step[prev] + 1;
    if (step[curr] == 3) {
        minn = 4;
    }
    for (auto it : neighbours[curr]) {
        if (it != prev) {
            minn = min(minn, walk(it, curr, minn));
        }
    }
    step[curr] = -1;
    return minn;
}
void visit(int curr) {
    if (!walked[curr]) {
        walked[curr] = true;
        for (auto it : neighbours[curr]) {
            visit(it);
        }
    }
}
int main() {
//    ios_base::sync_with_stdio(false);
//    cin.tie(0);
//    cout.tie(0);

    int n;
    cin >> n;
    step[0] = -1;
    step[n] = -1;
    for (int i = 1; i < n; i++) {
        step[i] = -1;
        walked[i] = false;
        string v;
        cin >> v;
        for (int j = 1; j + i <= n + 1; j++) {
            if (v[j - 1] == '1') {
                neighbours[i].push_back(i + j);
                neighbours[i + j].push_back(i);
            }
        }
    }
    int minn = MAXN;
    for (int i = 1; i <= n; i++) {
        if (!walked[i]) {
            minn = min(minn, walk(i, 0, MAXN));
            visit(i);
        }
    }
    if (minn == MAXN) {
        cout << -1;
    } else {
        cout << minn;
    }
    return 0;
}

