#include<iostream>
#include<queue>
#define endl '\n'
using namespace std;
int n,m,md[2005][2005];
const int INF=10000005;
string a[5005];
bool used[2005][2005];
priority_queue< pair< pair<int,int>,int> > q;
bool operator<(pair< pair<int,int>,int> a, pair< pair<int,int>,int> b)
{
    return a.second>b.second;
}
int main()
{
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    cin>>n>>m;


    for(int i=0;i<n;i++)
    {
        cin>>a[i];
        for(int j=0;j<m;j++)
            md[i][j]=INF;
    }

    if(a[0][0]=='#' || a[n-1][m-1]=='#') {cout<<-1<<endl;return 0;}

    q.push({{0,0},0});
    md[0][0]=0;

    int tim=max(m,n);

    while(!q.empty())
    {
        pair<int,int> cell=q.top().first;
        int mintim=q.top().second;

        q.pop();

        if(cell.first==n-1 && cell.second==m-1)
        {
            cout<<mintim<<endl;
            return 0;
        }

        if(used[cell.first][cell.second]) continue;

        used[cell.first][cell.second]=1;

        for(int t=mintim+1;t<=tim;t++)
        {
                if(cell.first>=t && a[cell.first-t][cell.second]!='#' && md[cell.first-t][cell.second]>t)
                {
                    md[cell.first-t][cell.second]=t;
                    q.push({{cell.first-t,cell.second},t});
                }

                 if(cell.second>=t && a[cell.first][cell.second-t]!='#' && md[cell.first][cell.second-t]>t)
                {
                    md[cell.first][cell.second-t]=t;
                    q.push({{cell.first,cell.second-t},t});
                }

                if(cell.first<n-t && a[cell.first+t][cell.second]!='#' && md[cell.first+t][cell.second]>t)
                {
                    md[cell.first+t][cell.second]=t;
                    q.push({{cell.first+t,cell.second},t});
                }

                  if(cell.second<m-t && a[cell.first][cell.second+t]!='#' && md[cell.first][cell.second+t]>t)
                {
                    md[cell.first][cell.second+t]=t;
                    q.push({{cell.first,cell.second+t},t});
                }
        }
    }

  cout<<-1<<endl;
  return 0;
}
