#include<iostream>
#include<vector>
#include<queue>
using namespace std;
#define MAXN 2200
#define MAXM 2500000
vector<int> susedi[MAXN];
vector<pair<int,int>> rebra;
int razst[MAXN][MAXN];
queue<int> q;
void dijkstra(int vr){
    int original = vr;
    q.push(vr);
    while(!q.empty()){
        vr = q.front();
        q.pop();
        //cout<<"za "<<original<<" sme vyv "<<vr<<" s dist = "<<dist<<"\n";
        for(auto to : susedi[vr]){
            if(razst[original][to]==MAXM){
                razst[original][to]=razst[original][vr]+1;
                q.push(to);
            }
        }
    }
}
int main () {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int n;
    cin>>n;
    string a;
    int ind;
    for(int i=1;i<n;i++){
        cin>>a;
        ind = i+1;
        for(int j=0;j<a.size();j++){
            //cout<<"pitam za "<<i<<" "<<j<<" ";
            if(a[j]=='1'){
                susedi[i].push_back(ind);
                susedi[ind].push_back(i);
                rebra.push_back({i,ind});
            }
            ind++;
        }
    }
    for(int i=1;i<=n;i++){
        for(int j=1;j<=n;j++){
            if(i!=j) razst[i][j]=MAXM;
        }
        dijkstra(i);
    }
    /*for(int i=1;i<=n;i++){
        for(int j=1;j<=n;j++){
            cout<<i<<" "<<j<<" "<<razst[i][j]<<"\n";
        }
    }*/
    int ans = MAXM;
    for(int i=1;i<=n;i++){
        for(int j=1;j<=n;j++){
            for(int p=1;p<=n;p++){
                for(int q=1;q<=n;q++){
                    if(i==j or i==p or i==q or j==p or j==q or p==q) continue;
                    if(razst[i][j]==1 and razst[p][q]==1 and razst[i][p]<MAXM and razst[j][q]<MAXM){
                        //cout<<i<<" "<<j<<" "<<p<<" "<<q<<" pravi "<<razst[i][p]+razst[j][q]<<"\n";
                        ans = min(ans,razst[i][p]+razst[j][q]);
                    }

                }
            }
        }
    }
    if(ans==MAXM) ans = -1;
    cout<<ans<<"\n";
    return 0;
}
