#include<iostream>
#include<vector>
#include<queue>
using namespace std;
#define MAXN 2200
#define MAXM 2500000
#define curr komponenta[k]
vector<int> susedi[MAXN];
vector<pair<int,int>> rebra;
int razst[MAXN][MAXN];
queue<int> q;
int comp[MAXN];
vector<int> komponenta[MAXN];
int minans[MAXN]; /// za komponentite
int brkomp = 0;
int podobr[MAXN];
void bfs(int vr){
    int original = vr;
    q.push(vr);
    while(!q.empty()){
        vr = q.front();
        if(comp[vr]==0){
            comp[vr]=brkomp;
            komponenta[brkomp].push_back(vr);
        }
        q.pop();
        //cout<<"za "<<original<<" sme vyv "<<vr<<" s dist = "<<dist<<"\n";
        for(auto to : susedi[vr]){
            if(razst[original][to]==MAXM){
                podobr[to]=vr;
                razst[original][to]=razst[original][vr]+1;
                q.push(to);
            }else if(razst[original][to]==razst[original][vr]+1 and podobr[podobr[to]]==podobr[vr]){
                minans[brkomp]=2;
            }
        }
    }
}
int main () {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int n;
    cin>>n;
    string a;
    int ind;
    for(int i=1;i<n;i++){
        cin>>a;
        ind = i+1;
        for(int j=0;j<a.size();j++){
            //cout<<"pitam za "<<i<<" "<<j<<" ";
            if(a[j]=='1'){
                susedi[i].push_back(ind);
                susedi[ind].push_back(i);
                rebra.push_back({i,ind});
            }
            ind++;
        }
    }
    for(int i=1;i<=n;i++){
        for(int j=1;j<=n;j++){
            if(i!=j) razst[i][j]=MAXM;
        }
        if(comp[i]==0){

            brkomp++;
            comp[i]=brkomp;
            minans[brkomp]=MAXM;
            komponenta[brkomp].push_back(i);
            bfs(i);
        }
    }

    int ans = MAXM;
    int l;
    for(int k=1;k<=brkomp;k++){
        l = komponenta[k].size();
        if(l<4) continue;
        ans = min(ans,4);
        ans = min(ans,minans[k]);
        /*for(int i=0;i<l;i++){
            bfs(curr[i]);
        }
        for(int i=0;i<l;i++){
            for(int j=0;j<l;j++){
                for(int p=0;p<l;p++){
                    for(int q=0;q<l;q++){
                        if(i==j or i==p or i==q or j==p or j==q or p==q) continue;
                        if(razst[curr[i]][curr[j]]==1 and razst[curr[p]][curr[q]]==1){
                            //cout<<i<<" "<<j<<" "<<p<<" "<<q<<" pravi "<<razst[i][p]+razst[j][q]<<"\n";
                            ans = min(ans,razst[curr[i]][curr[p]]+razst[curr[j]][curr[q]]);
                        }

                    }
                }
            }
        }*/
    }

    if(ans==MAXM) ans = -1;\
    else cout<<3<<"\n";
    //cout<<ans<<"\n";
    return 0;
}
