#include <bits/stdc++.h>

#include "crption.h"

#ifdef __LOCAL__
#include "Lgrader.cpp"
#endif // __LOCAL__

using namespace std;

const int MAXN = 1e5 + 50;

int parent[MAXN];
int child[MAXN];

int TrueGraph[MAXN];

vector <int> solve (const int &N, const vector <int> &from, const vector<int> &to)
{
    memset(parent, -1, sizeof(parent));
    memset(child, -1, sizeof(child));
    memset(TrueGraph, -1, sizeof(TrueGraph));

    int M = from.size();

    for (int i = 0; i < M; i++)
    {
        int currParent = from[i];
        int currChild = to[i];

        //cout << "!" << currParent << " " << currChild << endl;
        //cout << "!" << child[currParent] << " " << parent[currChild] << endl << endl;

        if (parent[currChild] == -1)
        {
            parent[currChild] = currParent;
            child[currParent] = currChild;

            TrueGraph[currParent] = currChild;
        }

        else
        {
            bool res = check(currParent, currChild);
            if (res == true)
            {

                TrueGraph[currChild] = currParent;
                parent[currParent] = currChild;
                child[currChild] = currParent;
            }

            else
            {
                TrueGraph[currParent] = currChild;
                parent[currChild] = currParent;
                child[currParent] = currChild;
            }
        }



    }
    vector <int> ans(N);

    int start = -1;
    for (int i = 0; i < N; i++)
        if (parent[i] == -1)
            start = i;

    int ind = 0;
    while (start != -1)
    {
        ans[ind++] = start;
        start = TrueGraph[start];
    }

    return ans;
}
