#include <bits/stdc++.h>

#include "crption.h"

#ifdef __LOCAL__
#include "Lgrader.cpp"
#endif // __LOCAL__

using namespace std;

const int MAXN = 1e5 + 50;

vector <int> Graph[MAXN];
vector <int> ans;

int parentCNT[MAXN];

void DFS(int curr)
{
    ans.push_back(curr);

    for (int i:Graph[curr])
        parentCNT[i]--;

    for (int i:Graph[curr])
    {
        if (parentCNT[i] == 0)
        {
            DFS(i);
            return;
        }
    }
}

vector <int> solve (const int &N, const vector <int> &from, const vector<int> &to)
{
    int M = from.size();

    for (int i = 0; i < M; i++)
    {
        int u = from[i];
        int v = to[i];
        bool res = check(u, v);

        if (res == true)
            swap(u, v);

        parentCNT[v]++;
        Graph[u].push_back(v);
    }

    int source = -1;
    for (int i = 0; i < N; i++)
        if (parentCNT[i] == 0)
            source = i;

    DFS(source);

    return ans;

}
