#include<bits/stdc++.h>
#define endl '\n'

using namespace std;
typedef long long ll;

void speed()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
}


const int maxn = 1e6 + 10, inf = 1e9;

struct cell
{
    int x, y;
    cell(int _x = 0, int _y = 0)
    {
        x = _x;
        y = _y;
    }
};
int n, m;
vector < char > c[maxn];
vector < int > dp[maxn];

   queue < cell > q[maxn];
void djikstra()
{

    dp[1][1] = 0;
    q[0].push(cell(1, 1));
    int cur_queue = 0;
    while(cur_queue < max(n, m))
    {
        if (q[cur_queue].size() == 0)
        {
            cur_queue ++;
            continue;
        }
        cell cur = q[cur_queue].front();
        q[cur_queue].pop();
        if (cur_queue > dp[cur.x][cur.y])
            continue;
        ///cout << cur.x << " " << cur.y << " " << cur_queue << endl;
        for (int i = 1; i <= n; i ++)
        {
            int t = abs(cur.x - i);
            if (t <= dp[cur.x][cur.y] || c[cur.x][cur.y] == '#')
                continue;
            if (t < dp[i][cur.y])
            {
                dp[i][cur.y] = t;
                q[t].push(cell(i, cur.y));
            }
        }


        for (int j = 1; j <= m; j ++)
        {
            int t = abs(cur.y - j);
            if (t <= dp[cur.x][cur.y] || c[cur.x][cur.y] == '#')
                continue;
            if (t < dp[cur.x][j])
            {
                dp[cur.x][j] = t;
                q[t].push(cell(cur.x, j));
            }
        }
    }

}

bool check(int x)
{
    int pos = m;
    while(pos > 1 && x > 0)
    {
        int new_pos = pos - x;
        if (new_pos < 1 || c[1][new_pos] == '#')
        {
            x --;
            continue;
        }
        pos = new_pos;
        x --;
    }
    return (pos == 1);
}
void solve()
{
    cin >> n >> m;
    for (int i = 0; i <= n + 1; i ++)
    {
        c[i].resize(m + 2);
        dp[i].resize(m + 2);
    }
    for (int i = 1; i <= n; i ++)
        for (int j = 1; j <= m; j ++)
        {
            cin >> c[i][j];
            dp[i][j] = inf;
        }

    if (n > 1)
    {
    djikstra();

    if (dp[n][m] == inf)
        cout << -1 << endl;
    else
        cout << dp[n][m] << endl;
    }
    else
    {
        int lf = 0, rf = m;
        while(lf <= rf)
        {
            ///cout << lf << " " << rf << endl;
            int mf = (lf + rf) / 2;
            if (check(mf))
                rf = mf - 1;
            else
                lf = mf + 1;
        }
        if (lf == m + 1)
            cout << -1 << endl;
        else
        cout << lf << endl;
    }


}

int main()
{
    solve();
    return 0;

}
/**
1 11
..#.#..###.
*/
