#include<bits/stdc++.h>
#define endl '\n'

using namespace std;
typedef long long ll;

void speed()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
}


const int maxn = 1e6 + 10, inf = 1e9;

struct cell
{
    int x, y;
    cell(int _x = 0, int _y = 0)
    {
        x = _x;
        y = _y;
    }
};
int n, m;
vector < char > c[maxn];
vector < int > dp[maxn];

   queue < cell > q[maxn];
void djikstra()
{

    dp[1][1] = 0;
    q[0].push(cell(1, 1));
    int cur_queue = 0;
    while(cur_queue < max(n, m))
    {
        if (q[cur_queue].size() == 0)
        {
            cur_queue ++;
            continue;
        }
        cell cur = q[cur_queue].front();
        q[cur_queue].pop();
        if (cur_queue > dp[cur.x][cur.y])
            continue;
        ///cout << cur.x << " " << cur.y << " " << cur_queue << endl;
        for (int i = 1; i < cur.x; i ++)
        {
            int t = abs(cur.x - i);

            if (t <= dp[cur.x][cur.y] || c[cur.x][cur.y] == '#')
                continue;

            if (t < dp[i][cur.y])
            {
                dp[i][cur.y] = t;
                q[t].push(cell(i, cur.y));
            }
        }

        for (int i = cur.x + 1; i <= n; i ++)
        {
            int t = abs(cur.x - i);
            if (c[i][cur.y] == '#')
                continue;
            if (dp[i][cur.y] + i - cur.x <= dp[cur.x][cur.y])
                break;
                        if (t <= dp[cur.x][cur.y] || c[cur.x][cur.y] == '#')
                continue;

            if (t < dp[i][cur.y])
            {
                dp[i][cur.y] = t;
                q[t].push(cell(i, cur.y));
            }
        }
        for (int j = 1; j <= m; j ++)
        {
            int t = abs(cur.y - j);
            if (t <= dp[cur.x][cur.y] || c[cur.x][cur.y] == '#')
                continue;
            if (t < dp[cur.x][j])
            {
                dp[cur.x][j] = t;
                q[t].push(cell(cur.x, j));
            }
        }
    }

}

int tree[4 * maxn], lazy[4 * maxn];
void push_lazy(int root, int left, int right)
{
    tree[root] += lazy[root];
    if (left != right)
    {
        lazy[root * 2] += lazy[root];
        lazy[root * 2 + 1] += lazy[root];
    }
    lazy[root] = 0;
}

void build_tree(int root, int left, int right)
{
    lazy[root] = 0;
    tree[root] = inf;
    if (left == right)
        return;

    int mid = (left + right) / 2;
    build_tree(root * 2, left, mid);
    build_tree(root * 2 + 1, mid + 1, right);
}

void update_range(int root, int left, int right, int qleft, int qright, int val)
{
    push_lazy(root, left, right);
    if (left > qright || right < qleft)
        return;

    if (left >= qleft && right <= qright)
    {
        lazy[root] += val;
        push_lazy(root, left, right);

        return;
    }

    int mid = (left + right) / 2;
    update_range(root * 2, left, mid, qleft, qright, val);
    update_range(root * 2 + 1, mid + 1, right, qleft, qright, val);

    tree[root] = min(tree[root * 2], tree[root * 2 + 1]);

}
void update_pos(int root, int left, int right, int pos, int val)
{
    push_lazy(root, left, right);
    if (left == right)
    {
        tree[root] = val;
        return;
    }

    int mid = (left + right) / 2;
    if (pos <= mid)
        update_pos(root * 2, left, mid, pos, val);
    else
        update_pos(root * 2 + 1, mid + 1, right, pos, val);


    tree[root] = min(tree[root * 2], tree[root * 2 + 1]);
     //cout << root << " --- " << left << " " << right <<  " " << tree[root] << endl;
       //  cout << tree[root * 2] << " "  << tree[root * 2 + 1] << endl;
}

int query(int root, int left, int right, int qleft, int qright)
{
    push_lazy(root, left, right);
    if (left > qright || right < qleft)
        return inf;

    if (left >= qleft && right <= qright)
    {
        ///cout << root << " ---- " << left << " " << right << " " << tree[root] << endl;
        return tree[root];
    }

        int mid = (left + right) / 2;
    return min(query(root * 2, left, mid, qleft, qright),
               query(root * 2 + 1, mid + 1, right, qleft, qright));
}
vector < int > upd[maxn];
void solve_line_dp()
{
    build_tree(1, 1, m);
    dp[1][1] = 0;
    //upd[2].push_back(1);
    /**update_pos(1, 1, m, 1, 1);
    update_range(1, 1, m, 1, 3, 1);
    update_pos(1, 1, m, 2, 1);
    update_range(1, 1, m, 1, 4, 1);
    update_range(1, 1, m, 1, 5, 1);
    cout << query(1, 1, m, 1, 4) << endl;
    exit(0);*/
    int best = 1;
    for (int i = 2; i <= m; i ++)
    {
        for (int v : upd[i])
        {
        ///cout << "upd " << i << " " << v << " " << dp[1][v] << endl;
            if (v > best)
                best = v;
        }
        if (c[1][i] == '#')
            continue;
        dp[1][i] = i - best;
        if (i + dp[1][i] + 1 <= m)
        {
            upd[i + dp[1][i] + 1].push_back(i);
        }
        ///cout << i << " " << dp[1][i] << endl;
    }
   /// cout << endl;
}

void solve()
{
    cin >> n >> m;
    for (int i = 0; i <= n + 1; i ++)
    {
        c[i].resize(m + 2);
        dp[i].resize(m + 2);
    }
    for (int i = 1; i <= n; i ++)
        for (int j = 1; j <= m; j ++)
        {
            cin >> c[i][j];
            dp[i][j] = inf;
        }

    if (n > 1)
    {
    djikstra();

    if (dp[n][m] == inf)
        cout << -1 << endl;
    else
        cout << dp[n][m] << endl;
    }
    else
    {
        solve_line_dp();
        cout << dp[1][m] << endl;
    }


}

int main()
{
    solve();
    return 0;

}
/**
1 15
...##.##.....#.
*/
