#include<bits/stdc++.h>
#define endl '\n'

using namespace std;
typedef long long ll;

void speed()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
}

const int maxn = 560, inf = 1e9;

int n, f[maxn][maxn], nb_cnt[maxn];
bitset < maxn > bt[maxn], st[maxn][maxn];
int dp[maxn][maxn];

vector < int > g[maxn];
int depth[maxn], used[maxn];
int cycle4, cycle5;
int dfs(int v)
{
    used[v] = 1;
    for (int u : g[v])
    {
        if (!used[u])
        {
            depth[u] = depth[v] + 1;
            dfs(u);
        }
        else
        {
            if (depth[u] < depth[v])
            {
                int dis = depth[v] - depth[u] + 1;
                if (dis == 4)
                    cycle4 = 1;
                if (dis == 5)
                    cycle5 = 1;
            }
        }
    }
}
void solve()
{
    cin >> n;
    for (int i = 1; i <= n; i ++)
        for (int j = 1; j <= n; j ++)
        {
            f[i][j] = inf;
            if (i == j)
                f[i][j] = 0;
        }

    for (int i = 1; i <= n; i ++)
        for (int j = i + 1; j <= n; j ++)
        {
            char c;
            cin >> c;
            f[i][j] = f[j][i] = c - '0';
            if (c == '0')
                f[i][j] = f[j][i] = inf;
            else
            {
                bt[i][j] = 1;
                bt[j][i] = 1;
                nb_cnt[i] ++;
                nb_cnt[j] ++;
                g[i].push_back(j);
                g[j].push_back(i);
            }
        }

    for (int i = 1; i <= n; i ++)
        if (!used[i])
            dfs(i);
    if (cycle4)
    {
        cout << 2 << endl;
        return;
    }
    for (int k = 1; k <= n; k ++)
        for (int i = 1; i <= n; i ++)
            for (int j = 1; j <= n; j ++)
            {
                if (f[i][k] + f[k][j] < f[i][j])
                {
                    f[i][j] = f[i][k] + f[k][j];
                }
            }

    int ans = inf;
    bool tf = false;
    for (int i = 1; i <= n; i ++)
        for (int j = 1; j <= n; j ++)
        {
            for (int k = 1; k <= n; k ++)
            {
                if (i == j || i == k || j == k)
                    continue;
                if (f[i][j] != 1 || f[j][k] != 1)
                    continue;
                for (int d = 1; d <= n; d ++)
                {
                    if (d == i || d == j || d == k)
                        continue;
                    if (f[k][d] == 1)
                    {
                        tf = true;
                    }
                }
            }
        }
    if (!tf)
    {
        cout << -1 << endl;
        return;
    }
    ans = 4;

    for (int i = 1; i <= n; i ++)
        for (int j = 1; j <= n; j ++)
        {
            for (int k = 1; k <= n; k ++)
            {
                if (i == j || i == k || j == k)
                    continue;
                if (f[i][j] != 1 || f[i][k] != 1 || f[j][k] != 1)
                    continue;
                if (nb_cnt[i] > 2 || nb_cnt[j] > 2 || nb_cnt[k] > 2)
                    ans = min(ans, 3);
            }
        }


    for (int i = 1; i <= n; i ++)
        for (int j = 1; j <= n; j ++)
        {
            if (i == j)
                continue;
            st[i][j] = (bt[i] & bt[j]);
            st[i][j][i] = 0;
            st[i][j][j] = 0;
            dp[i][j] = st[i][j].count();
            if (dp[i][j] >= 2)
                ans = 2;
            /**int cnt = 0;
                for (int k = 1; k <= n; k ++)
                {
                    if (k == i || k == j)
                    continue;
                    if (f[i][k] == 1 && f[j][k] == 1)
                        cnt ++;
                }
                if (cnt >= 2)
                    ans = min(ans, 2);*/
        }


    for (int i = 1; i <= n; i ++)
        for (int j = 1; j <= n; j ++)
            for (int k = 1; k <= n; k ++)
            {
                if (i == j || i == k || j == k)
                    continue;
                if (f[i][j] != 1)
                    continue;
                int c1 = dp[i][k], c2 = dp[j][k];
                if (st[i][k][j] == 1)
                    c1 --;
                if (st[j][k][i] == 1)
                    c2 --;
                if (c1 > 0 && c2 > 0)
                    ans = min(ans, 3);

            }
    int temp_ans = ans;


    cout << ans << endl;
    return;





}

int main()
{
    solve();
    return 0;

}
/**
4
100
11
1
*/
