#include <bits/stdc++.h>
#include "crption.h"

using namespace std;

const int maxn = 1e5 + 10, maxk = 5e5 + 10;
int used[maxn], in_deg[maxn], nxt[maxn];
vector < int > g[maxn], ord;
vector < int > go_in[maxn], go_out[maxn];
void topsort(int v)
{
    used[v] = 1;
    for (int u : g[v])
    {
        if (!used[u])
        topsort(u);
    }
    ord.push_back(v);
}
vector<int> solve(const int &n, const vector<int> &from, const vector<int> &to)
{
    int root, m = from.size();
    for (int i = 0; i < m; i ++)
    {
        int v, u;
        v = from[i];
        u = to[i];
        go_out[v].push_back(u);
        go_out[u].push_back(v);
        ///cout << "edge " << v << " " << u << endl;
    }

    for (int v = 1; v <= n; v ++)
    {
        if (go_out[v].size() > maxk || go_in[v].size() > maxk)
        {
            for (int u : go_out[v])
            {
                in_deg[u] ++;
                g[v].push_back(u);
            }
            for (int u : go_in[v])
            {
                in_deg[v] ++;
                g[u].push_back(v);
            }
            continue;
        }

        for (int u : go_out[v])
        {
            if (check(v, u))
            {
                                in_deg[v] ++;
                g[u].push_back(v);
            }
            else
            {
                in_deg[u] ++;
                g[v].push_back(u);
            }
        }

        for (int u : go_in[v])
        {
            if (check(v, u) == false)
            {
                                in_deg[v] ++;
                g[u].push_back(v);
            }
            else
            {
                in_deg[u] ++;
                g[v].push_back(u);
            }
        }
    }
    root = 0;
    while(root < n && in_deg[root] > 0)
        root ++;

    topsort(root);
    reverse(ord.begin(), ord.end());
    return ord;
}

