#include <bits/stdc++.h>
#define endl '\n'
using namespace std;
const int MAXN = 5005;
void speed()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
}
/// harakteriziram vsqka kletka s edno chislo i*n + m
int dist[MAXN][MAXN];
int n, m, a[MAXN][MAXN], dp[MAXN][MAXN];
void read()
{
    cin >> n >> m;
    char type;
    for (int i = 1; i <= n; ++ i)
    {
        for (int j = 1; j <= m; ++ j)
        {
            cin >> type;
            if(type == '#')
                a[i][j] = -1;
        }
    }
}
void precompute_dist()
{
    for (int i = 1; i <= n; ++ i)
    {
        for (int j = 1; j <= m; ++ j)
        {
            int nomer1 = (i-1) * m + j, nomer2;
            /// up
            for (int k = i-1; k >= 1; -- k)
            {
                nomer2 = (k-1) * m + j;
                dist[nomer1][nomer2] = i - k;
            }
            /// down
            for (int k = i+1; k <= n; ++ k)
            {
                nomer2 = (k-1) * m + j;
                dist[nomer1][nomer2] = k - i;
            }
            /// left
            for (int k = j-1; k>= 1; -- k)
            {
                nomer2 = (i-1)*m + k;
                dist[nomer1][nomer2] = j - k;
            }
            /// right
            for (int k = j+1; k <= m; ++ k)
            {
                nomer2 = (i-1)*m + k;
                dist[nomer1][nomer2] = k - j;
            }
        }
    }
}
int ans = 1e9 + 10;
int used[MAXN];
void dfs(int beg, int maxt)
{
    used[beg] = 1;
    if(beg == n * m)
    {
        ans = min(ans, maxt);
        return;
    }
    for (int i = 1; i <= n*m; ++ i)
    {
        if(!used[i])
        {
            int row = i / m;
        if(i % m != 0)row ++;
        int column = i % m;
        if(a[row][column] == -1)continue;
        int t = dist[beg][i];
        if(t <= maxt)continue;
        if(t > ans)continue;
        dfs(i, t);
        }
    }
    //used[beg] = 0;
}
int main()
{
    speed();

    read();
    precompute_dist();
    dfs(1, 0);
    if(ans != 1e9+10)
        cout << ans << endl;
    else cout << -1 << endl;
    return 0;
}
