#include <bits/stdc++.h>
#define endl '\n'
using namespace std;
const int MAXN = 115;
void speed()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
}

int n;
vector < int > v[MAXN];
int dist[MAXN][MAXN];
void read()
{
    cin >> n;
    char x;
    for (int i = 1; i <= n; ++ i)
    {
        for (int j = i + 1; j <= n; ++ j)
        {
            cin >> x;
            if(x == '1')
            {
                v[i].push_back(j);
                v[j].push_back(i);
            }
        }
    }
}
int used[MAXN];
void bfs(int beg)
{
    memset(used, 0, sizeof(used));
    queue < int > q;
    used[beg] = 1;
    q.push(beg);
    int w, nb;
    while(!q.empty())
    {
        w = q.front();
        q.pop();
        for (int i = 0; i < v[w].size(); ++ i)
        {
            nb = v[w][i];
            if(!used[nb])
            {
                dist[beg][nb] = dist[beg][w] + 1;
                q.push(nb);
                used[nb] = 1;
            }
        }
    }
}
void precompute()
{
    for (int i = 1; i <= n; ++ i)
        bfs(i);

}

void print()
{
    for (int i = 1; i <= n; ++ i)
    {
        for (int j = 1; j <= n; ++ j)
            cout << dist[i][j] << " ";
        cout << endl;
    }
}

void solve()
{
    int ans = 1e9+10;
    for (int u1 = 1; u1 <= n; ++ u1)
    {
        for (int v1 = 1; v1 <= n; ++ v1)
        {
            if(u1 == v1)continue;
            if(dist[u1][v1] != 1)continue;
            for (int u2 = 1; u2 <= n; ++ u2)
            {
                if(u2 == u1 || u2 == v1)continue;
                for (int v2 = 1; v2 <= n; ++ v2)
                {
                    if(u2 == v2)continue;
                    if(dist[u2][v2] != 1)continue;
                    if(v2 == u1 || v2 == v1)continue;
                    if(ans > dist[v1][v2] + dist[u1][u2] && dist[u1][u2] && dist[v1][v2])
                    {
                       // cout << u1 << " " << v1 << " " << u2 << " " << v2 << endl;
                      //  cout << dist[v1][v2] + dist[u1][u2] << endl;
                        ans = dist[v1][v2] + dist[u1][u2];
                    }
                }
            }
        }
    }
    if(ans != 1e9 + 10)cout << ans << endl;
    else cout << -1 << endl;
}
int main()
{
    speed();
    read();
    //cout << "reading ended" << endl;
    precompute();
    //print();
    solve();
    return 0;
}
