#include<iostream>
#include<queue>
using namespace std;

const int MAXN = 5000;

vector<int> graph[MAXN];
bool v[MAXN];
int edges=0, nodes=0;

void BFS(int idx)
{
    queue<int> q;
    q.push(idx);

    while(!q.empty())
    {
        idx=q.front();
        q.pop();

        if(v[idx])
        {
            continue;
        }
        v[idx]=true;

        edges++;
        nodes+=graph[idx].size();

        for(int x:graph[idx])
        {
            q.push(x);
        }
    }
}

int main()
{
    //ios_base::sync_with_stdio(0);
    //cin.tie(0);

    int n;
    cin >> n;

    for(int i=0; i<n; i++)
    {
        v[i]=false;
        for(int j=0; j<n-1-i; j++)
        {
            int t;
            cin >> t;

            if(t)
            {
                graph[i].push_back(j);
                graph[j].push_back(i);
            }
        }
    }

    /*for(int i=0; i<n; i++)
    {
        cout << i << " -> ";
        for(int x:graph[i])
        {
            cout << x << " ";
        }
        cout << "\n";
    }*/

    for(int i=0; i<n; i++)
    {
        if(!v[i])
        {
            edges=0;
            nodes=0;
            BFS(i);

            nodes/=2;

            if(edges>=4 && nodes>=edges)
            {
                cout << "3\n";
                return 0;
            }
        }
    }

    cout << "4\n";

    return 0;
}
