#include "crption.h"
#include<queue>
#include<algorithm>
using namespace std;

const int MAXN=1e5;

vector<int> mygraph[MAXN];
bool mycorrupt[MAXN];
int mycnt[MAXN];

vector<int> solve(const int &n, const vector<int> &from, const vector<int> &to)
{
    vector<int> ans;

    for(int i=0; i<n; i++)
    {
        mycnt[i]=0;
        mycorrupt[i]=false;
    }

    int m=from.size(), k=0;
    for(int i=0; i<m; i++)
    {
        if(check(from[i], to[i]))
        {
            mycorrupt[i]=true;
            k++;
        }

        if(k==20)
        {
            break;
        }
    }

    for(int i=0; i<m; i++)
    {
        if(mycorrupt[i])
        {
            mygraph[to[i]].push_back(from[i]);
            mycnt[from[i]]++;
        }
        else
        {
            mygraph[from[i]].push_back(to[i]);
            mycnt[to[i]]++;
        }
    }

    for(int i=0; i<n; i++)
    {
        if(mycnt[i]==0)
        {
            queue<int> q;
            q.push(i);

            while(!q.empty())
            {
                int x=q.front();
                q.pop();
                ans.push_back(x);

                for(int y:mygraph[x])
                {
                    mycnt[y]--;

                    if(mycnt[y]==0)
                    {
                        q.push(y);
                    }
                }
            }

            break;
        }
    }

    return ans;
}
/*
4 3 0
0 2 1 3
0 2
2 1
1 3
*/
