#include<vector>
#include<queue>
#include "crption.h"

vector<int> gr1[56];
vector<int> gr2[56];
bool went[56];
bool gone[56];

int fn(int x)
{
    if(went[x]) return -1;

    if(gr1[x].size()==0) return x;

    int ret=-1;

    went[x]=true;
    for(int i=0;i<gr1[x].size();i++)
        ret=max(ret,fn(gr1[x][i]));

    return ret;
}

vector <int> solve (const int &N, const vector <int> &from, const vector<int> &to)
{

    for(int i=0;i<N;i++)
    {
        bool ff=check(from[i],to[i]);
        if(!ff)
        {
            gr1[from[i]].push_back(to[i]);
            gr2[to[i]].push_back(from[i]);
        }
        else
        {
            gr1[to[i]].push_back(from[i]);
            gr2[from[i]].push_back(to[i]);
        }
    }

    int x=fn(0);

    vector<int> sol;
    queue<int> q;
    q.push(x);

    gone[x]=true;
    
    while(!q.empty())
    {
        x=q.front();
        q.pop();

        sol.push_back(x);

        for(int i=0;i<gr2[x].size();i++)
            if(!gone[gr2[x][i]])
            {
                gone[gr2[x][i]]=true;
                q.push(gr2[x][i]);
            }
    }

    return sol;
}
