#include<bits/stdc++.h>
#define endl '\n'
using namespace std;
const int MAX_NM = 1e6+2;
const int INF = 1e9+7;
vector<vector<bool>> a;
int dist[MAX_NM];
int n,m;
char c;
int code(int i0, int j0)
{
    return i0*m+j0;
}
pair<int,int> decode(int num)
{
    return {num/m,num%m};
}
void solve()
{
    cin>>n>>m;
    a.resize(n,vector<bool>(m));
    for(int i=0; i<n; i++)
    {
        for(int j=0; j<m; j++)
        {
            cin>>c;
            if(c == '.') a[i][j] = 0;
            else a[i][j] = 1;
        }
    }
    for(int i=0; i<=n*m-1; i++) dist[i] = INF;
    priority_queue<pair<int,int>> pq;
    pq.push({0,0});
    while(!pq.empty())
    {
        int t = -pq.top().first+1;
        pair<int,int> curr = decode(pq.top().second);
        pq.pop();
        if(curr.first == n-1 && curr.second == m-1)
        {
            cout<<t-1<<endl;
            return;
        }
        for(int jump=t; jump+curr.first<n; jump++)
        {
            int idx = code(jump+curr.first,curr.second);
            if(a[jump+curr.first][curr.second] == 0 && dist[idx] > jump)
            {
                dist[idx] = jump;
                pq.push({-jump,idx});
            }
        }
        for(int jump=t; jump+curr.second<m; jump++)
        {
            int idx = code(curr.first,jump+curr.second);
            if(a[curr.first][jump+curr.second] == 0 && dist[idx] > jump)
            {
                dist[idx] = jump;
                pq.push({-jump,idx});
            }
        }
    }
    cout<<-1<<endl;
    return;
}
int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    solve();
}
