#include<bits/stdc++.h>
#define endl '\n'
using namespace std;
const int MAX_N = 5002;
int depth[MAX_N];
int ans = 1e9+7;
int compsize;
int cycle3,cycle5;
vector<int> adj[MAX_N];
vector<int> comp;
int triple_cycle[MAX_N];
void dfs(int cur, int par)
{
    compsize++;
    for(auto x: adj[cur])
    {
        if(x == par) continue;
        if(depth[x] == 0)
        {
            depth[x] = depth[cur]+1;
            dfs(x, cur);
        }
        else
        {
            if(depth[cur]-depth[x]+1 == 4)
            {
                cout<<2<<endl;
                exit(0);
            }
            if(depth[cur]-depth[x]+1 == 3)
            {
                triple_cycle[cur] = 1;
                cycle3 = 1;
                if(par != -1 && triple_cycle[par]==1)
                {
                    cout<<2<<endl;
                    exit(0);
                }
            }
            if(depth[cur]-depth[x]+1 == 5)
            {
                cycle5 = 1;
            }
        }
    }
}
void solve()
{
    int n;
    string f;
    cin>>n;
    for(int i=1; i<=n-1; i++)
    {
        cin>>f;
        for(int j=0; j<f.size(); j++)
        {
            if(f[j]=='1')
            {
                adj[i].push_back(j+i+1);
                adj[j+i+1].push_back(i);
            }
        }
    }
    for(int i=1; i<=n; i++)
    {
        if(i%2==1)
        random_shuffle(adj[i].begin(),adj[i].end());
    }
    for(int i=n; i>=1; i--)
    {
        if(depth[i] == 0)
        {
            compsize = 0;
            depth[i] = 1;
            cycle3 = 0;
            cycle5 = 0;
            dfs(i,-1);
            if(compsize >= 4) ans = min(ans,4);
            if(cycle3)
            {
                if(compsize >= 4) ans = min(ans,3);
            }
            if(cycle5)
            {
                ans = min(ans,3);
            }
        }
    }
//    for(int i=1; i<=n; i++)
//    {
//        cout<<depth[i]<<" ";
//    }
//    cout<<endl;
    if(ans > 4) cout<<-1<<endl;
    else cout<<ans<<endl;
}
int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    solve();
}
/**
4
111
11
1
*/
