#include<bits/stdc++.h>
using namespace std;

long long INF=(long long)1e6;
vector<long long> sus[5096];
bool vis[5096];
long long dp[5096][5096];
long long len=0;
long long n;

void findPath(long long a, long long b, long long u)
{
    if(!vis[u])
    {
        vis[u]=true;
        for(auto v: sus[u])
        {
            if(vis[v]) continue;
            len++;
            if(v==b)
            {
                dp[a][b]=min(len,dp[a][b]);
                dp[b][a]=min(len,dp[b][a]);
            }
            findPath(a,b,v);
            len--;
        }
    }
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    cin>>n;
    for(long long i=0;i<n-1;i++)
    {
        string txt;
        cin>>txt;
        for(long long k=n-1;k<n+n-2-i;k++)
        {
            if(txt[k-n+1]=='1')
            {
                sus[i].push_back(k);
                sus[k].push_back(i);
                dp[i][k]=1;
                dp[k][i]=1;
            }
        }
    }
    for(long long i=0;i<2*(n-1)-1;i++)
    {
        for(long long k=i+1;k<2*(n-1);k++)
        {
            if(dp[i][k]==1) continue;
            dp[i][k]=INF;
            dp[k][i]=INF;
            findPath(i,k,i);
        }
    }
    long long ans=INF;
    n=2*n-2;
    for(long long i=0;i<n-1;i++)
    {
        long long u1=i;
        for(long long p=0;p<sus[u1].size();p++)
        {
            long long v1=sus[u1][p];
            for(long long k=i+1;k<n;k++)
            {
                if(k==v1) continue;
                long long u2=k;
                for(auto v2: sus[u2])
                {
                    if(v2==v1||v2==u1) continue;
                    ans=min(ans, dp[u1][u2]+dp[v1][v2]);
                }
            }
        }
    }
    if(ans==INF) cout<<-1<<endl;
    else cout<<ans<<endl;
}
