#include <bits/stdc++.h>
#define endl '\n'
#define INF 2e9
using namespace std;
void FastIO()
{
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
}
const int MAXM = 5555;
int a[MAXM][MAXM];
int n;
void floyd()
{
     for(int k = 1; k <= n; k ++)
    {
        for(int i = 1; i <= n; i ++)
        {
            for(int j = 1; j <= n; j ++)
            {
                if(a[i][k] + a[k][j] < a[i][j]) a[i][j] = a[i][k] + a[k][j];
            }
        }
    }
}
vector <vector<int>> G;
vector<pair<int, int>> q;
int main ()
{
    FastIO();

    cin >> n;
    string s;
    for(int i = 1; i < n; i ++)
    {
        cin >> s;
        for(int j = i+1; j <= s.size()+i; j ++)
        {
            if(s[j-i-1] == '1')
            {
                a[i][j] = 1;
                a[j][i] = a[i][j];
                q.push_back({i, j});
                //cout << i << " " << j << endl;
            }
            else
            {
                a[i][j] = INF;
                a[j][i] = INF;
            }
        }
    }

    floyd();


    int mini = INF;
    for(int i = 0; i < q.size(); i ++)
    {
        int u1 = q[i].first, v1 = q[i].second;
        //cout << i+1 << " : " << u1 << " " << v1 << endl;
        for(int j = i+1; j < q.size(); j ++)
        {
            if(q[j].first != u1 && q[j].second != v1 && q[j].first != v1 && q[j].second != u1)
            {
                //cout << q[j].first << " " << q[j].second << endl;
                int sum1, sum2, sum3, sum4;
                sum1 = a[q[j].first][u1];
                sum2 = a[q[j].second][u1];
                sum3 = a[q[j].first][v1];
                sum4 = a[q[j].second][v1];
                //cout << sum1 << " " << sum2 << " " << sum3 << " " << sum4 << endl;
                if(sum1 + sum4 < sum2 + sum3) mini = min(mini, sum1 + sum4);
                else mini = min(mini, sum2 + sum3);
            }
        }
    }
    cout << mini << endl;
    return 0;
}
