#include<bits/stdc++.h>
#define pb push_back
using namespace std;

template<class T> using matrix = vector<vector<T>>;

int N;
matrix<int> G;

int bfs(int s, int f){
    vector<int> used(N + 1), dist(N + 1, 1e9);
    queue<int> q;
    q.push(s);
    dist[s] = 0;
    while(!q.empty()){
        int u = q.front(); q.pop();
        if(used[u]) continue;
        used[u] = true;
        for(auto v : G[u]){
            dist[v] = min(dist[v], dist[u] + 1);
            q.push(v);
        }
    }
    return dist[f];
}

int main(){
    cin >> N;
    G = matrix<int>(N + 1);
    for(int u = 1; u < N; u ++){
        for(int v = u + 1; v <= N; v ++){
            int x; cin >> x;
            if(x){
                G[u].pb(v);
                G[v].pb(u);
            }
        }
    }
    int ans = 1e9;
    for(int u1 = 1; u1 <= N; u1 ++) for(int u2 = 1; u2 <= N; u2 ++) for(int v1 = 1; v1 <= N; v1 ++) for(int v2 = 1; v2 <= N; v2 ++){
        if(u1 == u2 || u1 == v1 || u1 == v2 || u2 == v1 || u2 == v2 || v1 == v2) continue;
        if(bfs(u1, v1) == 1 && bfs(u2, v2) == 1 && bfs(u1, u2) < 1e9 && bfs(v1, v2) < 1e9){
            /// cout << u1 << " " << u2 << " " << v1 << " " << v2 << endl;
            /// cout << "my = " << bfs(u1, u2) + bfs(v1, v2) << endl;
            ans = min(ans, bfs(u1, u2) + bfs(v1, v2));
        }
    }
    cout << ans << endl;
}
