#include<bits/stdc++.h>
#define pb push_back
using namespace std;

template<class T> using matrix = vector<vector<T>>;

int N;
matrix<int> G, dist;

int main(){
    cin >> N;
    G = matrix<int>(N + 1);
    dist = matrix<int>(N + 1, vector<int>(N + 1, 1e9));
    for(int u = 1; u < N; u ++){
        for(int v = u + 1; v <= N; v ++){
            int x; cin >> x;
            if(x){
                G[u].pb(v);
                G[v].pb(u);
            }
        }
    }
    for(int s = 1; s <= N; s ++){
        dist[s][s] = 0;
        queue<int> q;
        vector<int> used(N + 1, 0);
        q.push(s);
        while(!q.empty()){
            int u = q.front(); q.pop();
            if(used[u]) continue;
            used[u] = true;
            for(auto v : G[u]){
                if(!used[v] && dist[s][v] > dist[s][u] + 1){
                    dist[s][v] = dist[s][u] + 1;
                    q.push(v);
                }
            }
        }
    }
    int ans = 1e9;
    for(int u1 = 1; u1 <= N; u1 ++) for(int u2 = 1; u2 <= N; u2 ++) for(int v1 = 1; v1 <= N; v1 ++) for(int v2 = 1; v2 <= N; v2 ++){
        if(u1 == u2 || u1 == v1 || u1 == v2 || u2 == v1 || u2 == v2 || v1 == v2) continue;
        if(dist[u1][v1] == 1 && dist[u2][v2] == 1 && dist[u1][u2] < 1e9 && dist[v1][v2] < 1e9){
            ans = min(ans, dist[u1][u2] + dist[v1][v2]);
        }
    }
    if(ans == 1e9) ans = -1;
    cout << ans << endl;
}
