#include<bits/stdc++.h>
#include "crption.h"

using namespace std;
#define pb push_back
#define all(A) A.begin(), A.end()


template<class T> using matrix = vector<vector<T>>;
matrix<int> T, G, F;
int M, curr;
vector<int> ord, used, col;

void dfs(int u){
    used[u] = true;
    for(auto v : G[u]) if(!used[v]){
        dfs(v);
    }
    ord.pb(u);
}

void color(int u, int c){
    col[u] = c;
    for(auto x : T[u]){
        if(!col[x]) color(x, c);
    }
}

vector <int> solve (const int &N, const vector <int> &from, const vector<int> &to){
    F = T = G = matrix<int>(N);
    col = used = vector<int>(N);
    int M = from.size();
    for(int i = 0; i < M; i ++){
        G[from[i]].pb(to[i]);
        T[to[i]].pb(from[i]);
    }
    for(int i = 0; i < N; i ++){
        if(!used[i]){
            dfs(i);
        }
    }
    reverse(all(ord));
    for(auto x : ord){
        if(!col[x]){
            color(x, ++ curr);
        }
    }
    for(int i = 0; i < M; i ++){
        int u = from[i], v = to[i];
        if(col[u] != col[v]) F[u].pb(v);
        else if(check(u, v)) F[v].pb(u);
        else F[u].pb(v);
    }
    ord.clear();
    used = vector<int>(N, false);
    swap(G, F);
    for(int i = 0; i < N; i ++){
        if(!used[i]){
            dfs(i);
        }
    }
    reverse(all(ord));
    return ord;
}
