#include <iostream>
#include <bitset>
#include <vector>
#define endl '\n'
using namespace std;

const int MAX = 5000;
const int MAXS = 250000;

int tab[MAX + 5][MAX + 5];
bitset<MAX + 5> dp[MAXS + 5];

int main()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    int n, m;
    cin >> n >> m;

    for (int i = 1; i <= n; ++ i)
    {
        for (int j = 1; j <= m; ++ j)
        {
            char c;
            cin >> c;
            if (c == '.') tab[i][j] = 1;
            else tab[i][j] = 0;
        }
    }

    dp[0][0] = 1;
    for (int i = 1; i <= n; ++ i)
    {
        for (int j = 1; j <= m; ++ j)
        {
            int b = dp[(i - 1) * m + j - 1][0];
            for (int t = 1; t <= max(n - i, m - j); ++ t)
            {
                if (i + t <= n and tab[i + t][j] and b == 1) dp[(i - 1 + t) * m + j - 1][t] = b;
                if (j + t <= m and tab[i][j + t] and b == 1) dp[(i - 1) * m + j - 1 + t][t] = b;
                b |= dp[(i - 1) * m + j - 1][t];
            }
        }
    }

    for (int t = 1; t <= max(n, m); ++ t)
    {
        if (dp[n * m - 1][t])
        {
            cout << t << endl;
            return 0;
        }
    }

    return 0;
}
