#include <iostream>
#include <ctime>
#define endl '\n'
using namespace std;

const int MAX = 5000;

int bit[MAX + 5][MAX + 5], tab[MAX + 5][MAX + 5];

int main()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    time_t st = clock();

    int n, m;
    cin >> n >> m;

    int k = n * m + 1;
    for (int i = 1; i <= n; ++ i)
    {
        for (int j = 1; j <= m; ++ j)
        {
            bit[i][j] = k;
            char c;
            cin >> c;
            if (c == '.') tab[i][j] = 1;
            else tab[i][j] = 0;
        }
    }

    bit[1][1] = 0;
    for (int t = 1; t < max(n, m); ++ t)
    {
        for (int i = 1; i <= n; ++ i)
        {
            for (int j = 1; j <= m; ++ j)
            {
                if (bit[i][j] >= t) continue;
                if (i + t <= n and tab[i + t][j] and bit[i + t][j] == k) bit[i + t][j] = t;
                if (i > t and tab[i - t][j] and bit[i - t][j] == k) bit[i - t][j] = t;
                if (j + t <= m and tab[i][j + t] and bit[i][j + t] == k) bit[i][j + t] = t;
                if (j > t and tab[i][j - t] and bit[i][j - t] == k) bit[i][j - t] = t;
            }
        }
        if (clock() - st > 0.695 * CLOCKS_PER_SEC)
        {
            cout << -1 << endl;
            return 0;
        }
        if (bit[n][m] < k)
        {
            cout << bit[n][m] << endl;
            return 0;
        }
    }

    cout << -1 << endl;

    return 0;
}
