#include <iostream>
#include <vector>
#define endl '\n'
using namespace std;

const int MAX = 5000;

vector<int> bit[MAX + 5], tab[MAX + 5];

int main()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    int n, m;
    cin >> n >> m;

    int k = n * m + 1;
    for (int i = 1; i <= n; ++ i)
    {
        bit[i].resize(m + 1);
        tab[i].resize(m + 1);
        for (int j = 1; j <= m; ++ j)
        {
            bit[i][j] = k;
            char c;
            cin >> c;
            if (c == '.') tab[i][j] = 1;
            else tab[i][j] = 0;
        }
    }

    bit[1][1] = 0;
    vector< pair<int, int> > active;
    active.push_back({1, 1});
    for (int t = 1; t < max(n, m); ++ t)
    {
        int sz = active.size();
        for (int p = 0; p < sz; ++ p)
        {
            int i = active[p].first, j = active[p].second;
            if (i + t <= n and tab[i + t][j] and bit[i + t][j] == k)
            {
                bit[i + t][j] = t;
                active.push_back({i + t, j});
            }
            if (i > t and tab[i - t][j] and bit[i - t][j] == k)
            {
                bit[i - t][j] = t;
                active.push_back({i - t, j});
            }
            if (j + t <= m and tab[i][j + t] and bit[i][j + t] == k)
            {
                bit[i][j + t] = t;
                active.push_back({i, j + t});
            }
            if (j > t and tab[i][j - t] and bit[i][j - t] == k)
            {
                bit[i][j - t] = t;
                active.push_back({i, j - t});
            }
        }
        if (bit[n][m] < k)
        {
            cout << bit[n][m] << endl;
            return 0;
        }
    }

    cout << -1 << endl;

    return 0;
}
