#include <iostream>
#include <vector>
#define endl '\n'
using namespace std;

const int MAXN = 5000;

int cnt = 0;
bool used[MAXN + 5];
vector<int> G[MAXN + 5];
int common[MAXN + 5][MAXN + 5];
int comp[MAXN + 5], cntcomp[MAXN + 5];

void DFS(int u)
{
    used[u] = true;
    comp[u] = cnt;
    cntcomp[cnt]++;
    for (auto v : G[u])
    {
        if (!used[v]) DFS(v);
    }
}

int main()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    int n;
    ///cin >> n;
    n = 5000;

    for (int i = 1; i <= n; ++ i)
    {
        for (int j = i + 1; j <= n; ++ j)
        {
            char c;
            ///cin >> c;
            c = '1';
            if (c == '1')
            {
                G[i].push_back(j);
                G[j].push_back(i);
            }
        }
    }

    bool flag = false;
    vector<int> active;
    for (int i = 1; i <= n; ++ i)
    {
        if (!used[i])
        {
            cnt++;
            DFS(i);
            if (cntcomp[cnt] > 3) flag = true;
        }
        if (cntcomp[comp[i]] > 3) active.push_back(i);
    }

    if (!flag)
    {
        cout << -1 << endl;
        return 0;
    }

    bool flag4 = false;
    for (auto u : active)
    {
        for (auto v : G[u])
        {
            if (v > u)
            {
                for (auto w : G[v])
                {
                    if (w != u)
                    {
                        if (common[u][w] == 0) common[u][w] = common[w][u] = v;
                        else
                        {
                            flag4 = true;
                            break;
                        }
                    }
                }
            }
        }
    }

    if (flag4)
    {
        cout << 2 << endl;
        return 0;
    }

    return 0;
}
