#include "crption.h"
///#include "Lgrader.cpp"
#include <iostream>
#include <vector>
#include <stack>
#define endl '\n'
using namespace std;

const int MAXN = 100000;

stack<int> st;
int deg[MAXN + 5];
bool used[MAXN + 5];
vector<int> G[MAXN + 5];

void DFS(int u)
{
    used[u] = true;
    for (auto v : G[u])
    {
        if (!used[v]) DFS(v);
    }
    st.push(u);
}

bool check(const int &from, const int &to);

vector<int> solve (const int &N, const vector <int> &from, const vector<int> &to)
{
    int sz = from.size();
    int k = 0;
    vector<int> f = from, t = to;
    for (int i = 0; i < sz; ++ i)
    {
        if (check(f[i], t[i]))
        {
            swap(f[i], t[i]);
            k++;
        }
        if (k == 20) break;
    }
    for (int i = 0; i < sz; ++ i)
    {
        G[f[i]].push_back(t[i]);
        deg[t[i]]++;
    }
    int u = 0;
    for (int i = 0; i < N; ++ i)
    {
        if (deg[i] == 0)
        {
            u = i;
            break;
        }
    }

    DFS(u);

    vector<int> ret;
    while (!st.empty())
    {
        ret.push_back(st.top());
        st.pop();
    }
    return ret;
}
