#include <bits/stdc++.h>
// #pragma GCC optimize("Ofast")
// #pragma GCC target("sse4")
using namespace std;

#ifndef LOCAL
#define cerr if(false)cerr
#endif // LOCAL
#define endl "\n"

template<class T, class T2> bool chkmin(T &a, const T2 &b) { return (a > b) ? a = b, 1 : 0; }
template<class T, class T2> bool chkmax(T &a, const T2 &b) { return (a < b) ? a = b, 1 : 0; }

#define out(x) "[" << #x << "=" << x << "]"

template<class T> ostream &operator <<(ostream &out, const vector<T> &arr) {
    for(const auto &it : arr) { out << it << " "; }
    return out;
}

struct debug {
    debug(const string &out = "") { cerr << "DEBUGGER " << out <<  ": "; }
    ~debug() { cerr << endl; }

    template<class T>
    debug& operator <<(const T& a) {
        cerr << a << " ";
        return *this;
    }
};

#define dbg debug(to_string(__LINE__))
#define dbg_(x) debug(to_string(__LINE__) + "_" + x)

typedef long long ll;
const ll mod = 1e9 + 7;
///----------------------------------------------///

const int MAX_N = 5e3 + 10;
int n;
int par[MAX_N], child[MAX_N];
int dist[MAX_N][MAX_N];
bitset<MAX_N> adj[MAX_N];

ll ans = 0;

void bfs(int x) {
    fill_n(par, MAX_N, -1);

    queue<int> q;
    q.push(x);
    dist[x][x] = 0;
    while(!q.empty()) {
        auto curr = q.front(); q.pop();
        for(int i = 0; i < n; i ++) {
            if(!adj[curr][i]) { continue; }
            if(par[i] == -1) {
                par[i] = curr;
                dist[x][i] = dist[x][curr] + 1;
            }
        }
    }
}

signed main() {
    /// ios_base::sync_with_stdio(false); cin.tie(NULL); cout.tie(NULL);

    cin >> n;
    for(int i = 0; i < n; i ++) {
        for(int j = i + 1; j < n; j ++) {
            char c;
            cin >> c;
            adj[i][j] = adj[j][i] = c == '1';
        }
    }

    for(int i = 0; i < n; i ++) {
        bfs(i);
    }

    for(int i = 0; i < n; i ++) {
        for(int j = 0; j < n; j ++) {
            for(int a = 0; a < n; a ++) {
                for(int b = 0; b < n; b ++) {
                    if(adj[i][j] && adj[a][b]) {
                        chkmax(ans, dist[i][j] + dist[a][b]);
                    }
                }
            }
        }
    }

    cout << ans << endl;
    return 0;
}

/// Tova e prekrasno, nali?


