#include <bits/stdc++.h>
// #pragma GCC optimize("Ofast")
// #pragma GCC target("sse4")
using namespace std;

#ifndef LOCAL
#define cerr if(false)cerr
#endif // LOCAL
#define endl "\n"

template<class T, class T2> bool chkmin(T &a, const T2 &b) { return (a > b) ? a = b, 1 : 0; }
template<class T, class T2> bool chkmax(T &a, const T2 &b) { return (a < b) ? a = b, 1 : 0; }

#define out(x) "[" << #x << "=" << x << "]"

template<class T> ostream &operator <<(ostream &out, const vector<T> &arr) {
    for(const auto &it : arr) { out << it << " "; }
    return out;
}

struct debug {
    debug(const string &out = "") { cerr << "DEBUGGER " << out <<  ": "; }
    ~debug() { cerr << endl; }

    template<class T>
    debug& operator <<(const T& a) {
        cerr << a << " ";
        return *this;
    }
};

#define dbg debug(to_string(__LINE__))
#define dbg_(x) debug(to_string(__LINE__) + "_" + x)

typedef long long ll;
const ll mod = 1e9 + 7;
///----------------------------------------------///

const int MAX_N = 5e3 + 10;
int n;
int par[MAX_N], child[MAX_N];
int dist[MAX_N][MAX_N];
bitset<MAX_N> adj[MAX_N];
bitset<MAX_N> dist2[MAX_N];

ll ans = 0;

void bfs(int x) {
    fill_n(par, MAX_N, -1);
    queue<int> q;
    q.push(x);
    dist[x][x] = 0;
    par[x] = 0;
    while(!q.empty()) {
        auto curr = q.front(); q.pop();
        if(dist[x][curr] > 3) { continue; }
        for(int i = 0; i < n; i ++) {
            if(!adj[curr][i]) { continue; }
            if(par[i] == -1) {
                par[i] = curr;
                dist[x][i] = dist[x][curr] + 1;
                q.push(i);
            }
        }
    }
}

signed main() {
    /// ios_base::sync_with_stdio(false); cin.tie(NULL); cout.tie(NULL);

    cin >> n;
    for(int i = 0; i < n; i ++) {
        for(int j = i + 1; j < n; j ++) {
            char c;
            cin >> c;
            adj[i][j] = adj[j][i] = c == '1';
        }
    }

    for(int i = 0; i < n; i ++) {
        bfs(i);
    }

    ans = mod;

    for(int i = 0; i < n; i ++) {
        for(int j = 0; j < n; j ++) {
            if(i == j) { continue; }
            if(!adj[i][j]) { continue; }
            for(int a = 0; a < n; a ++) {
                if(i == a || j == a) { continue; }
                for(int b = 0; b < n; b ++) {
                    if(i == b || j == b || a == b) { continue; }
                    if(dist[a][b] != 1) { continue; }
                    if(dist[i][a] == 0 || dist[j][b] == 0) { continue; }
                    chkmin(ans, dist[i][a] + dist[j][b]);
                }
            }
        }
    }

    int old = ans;
    ans = mod;

    for(int i = 0; i < n; i ++) {
        for(int j = 0; j < n; j ++) {
            for(int k = j + 1; k < n; k ++) {
                if(adj[j][i] && adj[k][i]) {
                    dist2[j][k] = dist2[k][j] = true;
                }
            }
        }
    }
    for(int i = 0; i < n; i ++) {
        for(int j = i + 1; j < n; j ++) {
            if(!adj[i][j]) { continue; }
            if((adj[i] & ~adj[j]).count() != 0 && (~adj[i] & adj[j]).count() != 0 ) {
                ans = 4;
            }
        }
    }
    for(int i = 0; i < n; i ++) {
        for(int j = 0; j < n; j ++) {
            if(i == j) { continue; }
            if((adj[i] & dist2[j]).count() >= 2) {
                ans = 3;
            }
        }
    }
    for(int i = 0; i < n; i ++) {
        for(int j = i + 1; j < n; j ++) {
            if((adj[i] & adj[j]).count() >= 2) {
                ans = 2;
            }
        }
    }

    if(old == 4 && old != ans) {
        assert(false);
    }

    if(ans == mod) {
        cout << -1 << endl;
    } else {
        cout << ans << endl;
    }
    return 0;
}

/// Tova e prekrasno, nali?
