#include <iostream>
#include <vector>
#include <queue>
using namespace std;
#pragma optimize ("O3")
#pragma target ("sse4")
#define endl '\n'
const int MAXN=5e3+10;
vector <int> v[MAXN];
queue <int> q;
int dist[MAXN][MAXN];
void bfs(int start) {
    q.push(start);
    while (!q.empty()) {
        int x=q.front();
        q.pop();
        for (auto i:v[x]) {
            if (i!=start && dist[start][i]==0) {
                dist[start][i]=dist[start][x]+1;
                q.push(i);
            }
        }
    }
}
int check_ans(int i, int j) {
    int minx, min1x;
    minx=min1x=-1;
    for (auto p:v[j]) {
        if (p==i) continue;
        if (minx==-1 || dist[i][p]<dist[i][minx]) {
            min1x=minx;
            minx=p;
        } else if (dist[i][p]<=dist[i][minx] && (min1x==-1 || dist[i][min1x]>dist[i][p]))min1x=p;
    }
    int ans=2*MAXN, vr;
    for (auto p:v[i]) {
        if (p==j) continue;
        if (p==minx) vr=min1x;
        else vr=minx;
        if (vr==-1) continue;
        ///cout << i << ' ' << j << ' ' << p << ' ' << vr << ' ' << dist[j][p] << ' ' << dist[i][vr] << endl;
        ans=min(ans,dist[j][p]+dist[i][vr]);
    }
    return ans;
}
int main () {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n;
    cin >> n;
    char z;
    for (int i=1;i<=n-1;i++) {
        for (int j=i+1;j<=n;j++) {
            cin >> z;
            if (z=='1') {
                v[i].push_back(j);
                v[j].push_back(i);
            }
        }
    }
    for (int i=1;i<=n;i++) bfs(i);
    int ans=2*n;
    for (int i=1;i<=n;i++) {
        for (int j=i+1;j<=n;j++) {
            ans=min(ans,check_ans(i,j));
        }
    }
    cout << ans << endl;
    return 0;
}
/**
4
111
11
1
**/
