#include <iostream>
#include <vector>
#include <queue>
using namespace std;
#pragma optimize ("O3")
#pragma target ("sse4")
#define endl '\n'
const int MAXN=5e3+10;
vector <int> v[MAXN];
queue <int> q;
int dist[MAXN][MAXN];
void bfs(int start) {
    q.push(start);
    dist[start][start]=0;
    while (!q.empty()) {
        int x=q.front();
        q.pop();
        for (auto i:v[x]) {
            if (i!=start && dist[start][i]==-1) {
                dist[start][i]=dist[start][x]+1;
                q.push(i);
            }
        }
    }
}
int check_ans(int i, int j) {
    int minx, min1x;
    minx=min1x=-1;
    for (auto p:v[j]) {
        if (p==i || dist[i][p]==-1) continue;
        if (minx==-1 || dist[i][p]<dist[i][minx]) {
            min1x=minx;
            minx=p;
        } else if (dist[i][p]<=dist[i][minx] && (min1x==-1 || dist[i][min1x]>dist[i][p]))min1x=p;
    }
    int ans=2*MAXN, vr;
    for (auto p:v[i]) {
        if (p==j || dist[j][p]==-1) continue;
        if (p==minx) vr=min1x;
        else vr=minx;
        if (vr==-1) continue;
        ///cout << i << ' ' << j << ' ' << p << ' ' << vr << ' ' << dist[j][p] << ' ' << dist[i][vr] << endl;
        ans=min(ans,dist[j][p]+dist[i][vr]);
    }
    return ans;
}
int main () {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n;
    cin >> n;
    char z;
    for (int i=1;i<=n-1;i++) {
        for (int j=i+1;j<=n;j++) {
            cin >> z;
            if (z=='1') {
                v[i].push_back(j);
                v[j].push_back(i);
            }
        }
    }
    for (int i=1;i<=n;i++) {
        for (int j=1;j<=n;j++) dist[i][j]=-1;
        bfs(i);
    }
    int ans=2*n+1;
    for (int i=1;i<=n;i++) {
        for (auto p1:v[i]) {
            for (int j=i+1;j<=n;j++) {
                if (j==p1 || dist[i][j]==-1) continue;
                for (auto p2:v[j]) {
                    if (p2==p1 || p2==i || dist[p1][p2]==-1) continue;
                    ans=min(ans,dist[i][j]+dist[p1][p2]);
                }
            }
        }
    }
    if (ans==2*n+1) cout << -1 << endl;
    else cout << ans << endl;
    return 0;
}
/**
5
1001
100
10
1
**/
