#include <iostream>
#include <bitset>
using namespace std;
#pragma optimize ("O3")
#pragma target ("sse4")
#define endl '\n'
const int MAXN=5e3+1;
bitset <MAXN> t[MAXN], cur;
int cnt[MAXN];
bool used[MAXN];
int n;
int dfs(int x) {
    used[x]=true;
    int res=1;
    for (int i=1;i<=n;i++) {
        if (!t[i][x] || used[i]) continue;
        res=max(res,dfs(i)+1);
    }
    return res;
}
int main () {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    cin >> n;
    char z;
    for (int i=1;i<=n-1;i++) {
        for (int j=i+1;j<=n;j++) {
            cin >> z;
            if (z=='1') {
                t[i][j]=t[j][i]=1;
                cnt[i]++; cnt[j]++;
            }
        }
    }
    bool fl=false;
    int s;
    for (int i=1;i<=n;i++) {
        for (int j=i+1;j<=n;j++) {
            cur=(t[i]&t[j]);
            s=0;
            for (int k=1;k<=n;k++) {
                if (k==i || k==j) continue;
                if (cur[k]) s++;
            }
            if (s>=2) {
                fl=true;
                break;
            }
        }
        if (fl) break;
    }
    if (fl) {
        cout << 2 << endl;
        return 0;
    }
    for (int i=1;i<=n;i++) {
        if (cnt[i]==1) continue;
        for (int j=1;j<=n;j++) cur[j]=0;
        for (int j=1;j<=n;j++) {
            if (i==j || t[i][j]==0) continue;
            cur=(cur|t[j]);
        }
        for (int j=1;j<=n;j++) {
            if (cur[j]==0 || j==i || t[i][j]) continue;
            for (int k=j+1;k<=n;k++) {
                if (cur[k]==0 || j==i || t[i][j]) continue;
                if (t[j][k]) {
                    fl=true;
                    break;
                }
            }
            if (fl) break;
        }
        if (fl) break;
    }
    if (fl) {
        cout << 3 << endl;
        return 0;
    }
    for (int i=1;i<=n;i++) {
        if (used[i]) continue;
        int s=dfs(i);
        if (s>3 || (s==3 || cnt[i]>1)) {
            fl=true;
            break;
        }
    }
    if (fl) cout << 4 << endl;
    else cout << -1 << endl;
    return 0;
}
/**
5
1111
000
00
0
**/
