#include "crption.h"
#include <iostream>
#include <vector>
#include <stack>
using namespace std;
const int MAXN=1e5+10;
vector <int> v[MAXN];
stack <int> st;
bool used[MAXN];
void dfs(int x) {
    used[x]=true;
    for (auto i:v[x]) {
        if (used[i]) continue;
        dfs(i);
    }
    st.push(x);
}
vector <int> solve (const int &N, const vector <int> &from, const vector <int> &to) {
    int n=N;
    int cnt=0;
    for (int i=0;i<from.size();i++) {
        if (cnt<20 && check(from[i],to[i])) {
            v[to[i]].push_back(from[i]);
            cnt++;
        } else v[from[i]].push_back(to[i]);
    }
    for (int i=0;i<n;i++) {
        if (!used[i]) dfs(i);
    }
    vector <int> ans;
    while (!st.empty()) {
        ans.push_back(st.top());
        st.pop();
    }
    return ans;
}
