#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

const ll Size=5e3+1;
ll n,colors=0,ans=1e18;
ll color[Size];
ll dist[Size][Size];
ll first[Size];
vector<ll> adj[Size];
ll visited[Size];
pair<ll,ll> closest[Size];

void reset_visited(){
    for(ll i=0;i<n;i++){
        visited[i]=0;
    }
}

bool find_cycle4(ll start_node,ll curr_node,ll depth){
    visited[curr_node]=1;
    first[curr_node]=depth;
    //cout<<start_node<<" "<<curr_node<<" "<<depth<<endl;
    if(depth==3){
        for(auto next_node:adj[curr_node]){
            if(next_node==start_node)
                return true;
        }
    }
    for(auto next_node:adj[curr_node]){
        if(!visited[next_node]){
            bool next=find_cycle4(start_node,next_node,depth+1);
            if(next)
                return true;
        }
    }
    return false;
}

bool find_cycle3(ll start_node,ll curr_node,ll depth){
    visited[curr_node]=1;
    first[curr_node]=depth;
    if(depth==2){
        for(auto next_node:adj[curr_node]){
            if(next_node==start_node)
                return true;
        }
    }
    for(auto next_node:adj[curr_node]){
        if(!visited[next_node]){
            bool next=find_cycle3(start_node,next_node,depth+1);
            if(next)
                return true;
        }
    }
    return false;
}

bool find_cycle5(ll start_node,ll curr_node,ll depth){
    visited[curr_node]=1;
    first[curr_node]=depth;
    if(depth==4){
        for(auto next_node:adj[curr_node]){
            if(next_node==start_node)
                return true;
        }
    }
    for(auto next_node:adj[curr_node]){
        if(!visited[next_node]){
            bool next=find_cycle3(start_node,next_node,depth+1);
            if(next)
                return true;
        }
    }
    return false;
}

bool find_cycle(ll start_node,ll curr_node,ll depth){
    visited[curr_node]=1;
    first[curr_node]=depth;
    if(depth>1){
        for(auto next_node:adj[curr_node]){
            if(next_node==start_node)
                return true;
        }
    }
    for(auto next_node:adj[curr_node]){
        if(!visited[next_node]){
            bool next=find_cycle3(start_node,next_node,depth+1);
            if(next)
                return true;
        }
    }
    return false;
}

int main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cin>>n;
    srand(7);
    for(ll i=0;i<n-1;i++){
        string a="";
        cin>>a;
        ll j=i+1;
        /*
        for(;j<n;j++){
            ld b=rand();
            if(b>3000){
                a+="0";
            }else{
                a+="1";
            }
        }
        cout<<a<<endl;
        */
        for(j=i+1;j<n;j++){
            dist[i][j]=a[j-i-1]-'0';
            if(dist[i][j]==0){
                dist[i][j]=1e18;
            }else{
                adj[i].push_back(j);
                adj[j].push_back(i);
            }
            dist[j][i]=dist[i][j];
        }
    }
    if(n<4){
        cout<<-1<<endl;
        return 0;
    }
    for(ll i=0;i<n;i++){
        bool r4=find_cycle4(i,i,0);
        if(r4){
            cout<<2<<endl;;
            return 0;
        }
        reset_visited();
        bool r3=find_cycle3(i,i,0);
        if(r3){
            ans=min((ll)3,ans);
        }
        reset_visited();
        bool r5=find_cycle5(i,i,0);
        if(r5){
            ans=min((ll)3,ans);
        }
        reset_visited();
        bool r=find_cycle(i,i,0);
        if(r){
            ans=min((ll)4,ans);
        }
    }
    if(ans==1e18){
        cout<<-1<<endl;
    }else{
        cout<<ans<<endl;
    }
    return 0;
}
/*
4
111
11
1

4
110
11
1

7
110000
11110
0011
000
00
0
*/
