#include <iostream>
#include <vector>

#include "crption.h"

using namespace std;

vector<int> solve(const int &n, const vector<int> &_from, const vector<int> &_to)
{
    vector<int> from = _from;
    vector<int> to = _to;

    int m = (int) from.size();

    vector<vector<int>> graph(n);
    vector<int> in_degree(n);

    for (int i = 0; i < m; ++i)
    {
        if (check(from[i], to[i]))
        {
            swap(from[i], to[i]);
        }

        graph[from[i]].push_back(to[i]);
        ++in_degree[to[i]];
    }

    vector<int> result;
    for (int i = 0; i < n; ++i)
    {
        if (in_degree[i] == 0)
        {
            int currv = i;
            result.push_back(currv);

            while (!graph[currv].empty())
            {
                currv = graph[currv][0];
                result.push_back(currv);
            }
        }
    }

    return result;
}

