#include <iostream>
#include <vector>
#include <queue>
#include <climits>
#include <algorithm>
#define MAX_N 115
using namespace std;

vector <vector<int>> susedi;
int n;
string input;
int table[MAX_N][MAX_N];

void deikstra(int start)
{
    priority_queue<pair<int, int>> opashka;
    opashka.push({0, start});
    pair<int, int> k;

    fill_n(table[start], n, INT_MAX);
    table[start][start]=0;

    while(!opashka.empty())
    {
        //cout << "*";
        k=opashka.top();
        opashka.pop();

        for(int i=0; i<susedi[k.second].size() ; i++)
        {
            //cout << k.second  << " " << susedi[k.second].size() << endl;
            if(table[start][susedi[k.second][i]]>(-1)*(k.first-1))
            {
                //cout <<  susedi[k.second][i] << " " << table[start][susedi[k.second][i]] << " " << k.first-1 << endl;
                table[start][susedi[k.second][i]]=(-1)*(k.first-1);
                //cout << k.first << endl;
                opashka.push({k.first-1, susedi[k.second][i]});
                //cout << k.first << endl;
            }
        }
    }
}

int main()
{
    cin >> n;
    susedi.resize(n);
    int ind;
    for(int i=0; i<n-1; i++)
    {
        cin >> input;
        ind = 0;
        for(int j=i+1; j<n; j++)
        {
            if(input[ind]=='1')
            {
                susedi[i].push_back(j);
                susedi[j].push_back(i);
            }
            ind++;
        }
    }

    for(int i=0; i<n; i++)
    {
        //cout << "*******";
        deikstra(i);
    }

    /*for(int i=0; i<n; i++)
    {
        for(int j=0; j<n; j++)
        {
            cout << table[i][j] << " ";
        }
        cout << endl;
    }*/

    int minsum = INT_MAX;
    int currsum;
    for(int i=0; i<n; i++)
    {
        for(int j=0; j<n; j++)
        {
            for(int k=0; k<n; k++)
            {
                for(int r=0; r<n; r++)
                {
                    if(i!=j && i!=k && i!=r && j!=r && j!=k && k!=r)
                    {
                        if(table[i][j]==1 && table[k][r]==1)
                        {
                            if(table[i][k]!=INT_MAX && table[j][r]!=INT_MAX)
                            {
                                currsum = table[i][k] + table[j][r];
                                if(currsum<minsum)
                                {
                                    minsum=currsum;
                                }
                            }
                        }
                    }
                }
            }
        }
    }

    if(minsum==INT_MAX)
    {
        cout << -1;
    }
    else
    {
        cout << minsum;
    }


    return 0;
}
