#include <bits/stdc++.h>
#pragma optimize("O3")
#define endl '\n'
using namespace std;

const int maxn = 128;
int n, d[maxn][maxn], a[4];
struct four
{
    int a1, a2, a3, a4;
};
set< pair < pair <int, int>, pair <int, int> > > s;
bool edge[maxn][maxn];
vector <int> v[maxn];

void read()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);

    cin >> n ;
    int i, j;
    char c;
    for (i=1; i<n; ++i)
    {
        for (j=i+1; j<=n; ++j)
        {
            cin >> c ;
            if (c == '1')
            {
                v[i].push_back(j);
                v[j].push_back(i);
                edge[i][j] = true;
                edge[j][i] = true;
            }
        }
    }
}

void bfs(int start)
{
    d[start][start] = 1;
    int e, nb, i, len;
    queue <int> q;
    q.push(start);
    while (!q.empty())
    {
        e = q.front(); q.pop();
        len = v[e].size();
        for (i=0; i<len; ++i)
        {
            nb = v[e][i];
            if (!d[start][nb])
            {
                d[start][nb] = d[start][e] + 1;
                q.push(nb);
            }
        }
    }
}

void solve()
{
    int i;
    for (i=1; i<n; ++i)
    {
        bfs(i);
        d[n][i] = d[i][n];
    }

    long long t, sum = LLONG_MAX;
    int nbi, j, nbj;
    for (i=1; i<=n; ++i)
    {
        for (nbi=1; nbi<=n; ++nbi)
        {
            if (!edge[i][nbi]) continue;
            for (j=1; j<=n; ++j)
            {
                if (j == i || j == nbi) continue;
                for (nbj=1; nbj<=n; ++nbj)
                {
                    if (!edge[j][nbj] || nbj == i || nbj == nbi) continue;
                    if (d[i][j] == 0) continue;
                    a[0] = i, a[1] = nbi, a[2] = j, a[3] = nbj;
                    sort(a, a+4);
                    pair < pair<int, int>, pair<int, int> > f = {{a[0], a[1]}, {a[2], a[3]}};
                    if (s.find(f) != s.end()) continue;
                    s.insert(f);
                    if (d[i][j] + d[nbi][nbj] < d[nbi][j] + d[nbj][i]) t = (long long)(d[i][j] + d[nbi][nbj] - 2);
                    else t = (long long)(d[nbi][j] + d[nbj][i] - 2);
                    if (t < sum) sum = t;
                }
            }
        }
    }
    if (sum != LLONG_MAX) cout << sum << '\n' ;
    else cout << "-1" << '\n' ;
}

int main()
{
    read();
    solve();
    return 0;
}

/*
5
1100
110
01
0
*/