#include <bits/stdc++.h>
#pragma optimize("O3")
#define endl '\n'
using namespace std;

const int maxn = 128;
int n, d[maxn][maxn];
vector <int> v[maxn];

void read()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);

    cin >> n ;
    int i, j;
    char c;
    for (i=1; i<n; ++i)
    {
        for (j=i+1; j<=n; ++j)
        {
            cin >> c ;
            if (c == '1')
            {
                v[i].push_back(j);
                v[j].push_back(i);
            }
        }
    }
}

void bfs(int start)
{
    d[start][start] = 1;
    int e, nb, i, len;
    queue <int> q;
    q.push(start);
    while (!q.empty())
    {
        e = q.front(); q.pop();
        len = v[e].size();
        for (i=0; i<len; ++i)
        {
            nb = v[e][i];
            if (!d[start][nb])
            {
                d[start][nb] = d[start][e] + 1;
                q.push(nb);
            }
        }
    }
}

void solve()
{
    int i;
    for (i=1; i<n; ++i)
    {
        bfs(i);
        d[n][i] = d[i][n];
    }

    int ii, len1, nbi, j, jj, len2, nbj, h;
    long long t, sum = LLONG_MAX;
    for (i=1; i<=n; ++i)
    {
        len1 = v[i].size();
        for (ii=0; ii<len1; ++ii)
        {
            nbi = v[i][ii];
            for (j=1; j<=n; ++j)
            {
                if (j == i || j == nbi) continue;
                len2 = v[j].size();
                for (jj=0; jj<len2; ++jj)
                {
                    nbj = v[j][jj];
                    if (nbj == i || nbj == nbi) continue;
                    if (d[i][j] == 0) continue;
                    if (d[i][j] + d[nbi][nbj] < d[nbi][j] + d[nbj][i]) t = d[i][j] + d[nbi][nbj] - 2;
                    else t = d[nbi][j] + d[nbj][i] - 2;
                    if (t < sum) sum = t;
                    //cout << i << " " << nbi << " " << j << " " << nbj << " " << t << endl;
                }
            }
        }
    }
    if (sum != LLONG_MAX) cout << sum << '\n' ;
    else cout << "-1" << '\n' ;
}

int main()
{
    read();
    solve();
    return 0;
}

/*
5
1100
110
01
0
*/