#include <bits/stdc++.h>
#include "crption.h"
using namespace std;

const int maxn = 1e5+2;
vector <int> v[maxn];
struct vertex
{
    int first, second;
};
vertex d[maxn];
bool beg[maxn], used[maxn];

void dfs(int ver)
{
    used[ver] = true;
    int i, len = v[ver].size();
    for (i=0; i<len; ++i)
    {
        d[v[ver][i]].first += (d[ver].first + 1);
        if (!used[v[ver][i]])
            dfs(v[ver][i]);
    }
}

bool cmp(vertex v1, vertex v2)
{
    if (v1.first == v2.first) return (v1.second < v2.second);
    return (v1.first < v2.first);
}

vector<int> solve(const int &n, const vector<int> &from, const vector<int> &to)
{
    memset(beg, 1, sizeof(beg));
    int m = from.size(), i;
    for (i=0; i<m; ++i)
    {
        bool k = check(from[i], to[i]);
        if (k)
        {
            v[to[i]].push_back(from[i]);
            beg[from[i]] = false;
        }
        else
        {
            v[from[i]].push_back(to[i]);
            beg[to[i]] = false;
        }
    }

    for (i=0; i<n; ++i)
    {
        d[i].second = i;
        if (beg[i])
        {
            d[i].first = 1;
            memset(used, 0, sizeof(used));
            dfs(i);
        }
    }

    sort(d, d+n, cmp);
    vector <int> ans(n);
    for (i=0; i<n; ++i)
    {
        ans[i] = d[i].second;
        //cout << i << " " << ans[i] << " " << d[i].first << endl;
    }
    return ans;
}

/*
4 3 1
0 2 1 3
0 2
2 1
1 3
2
*/