#include<iostream>
#define endl "\n"
using namespace std;

int const MAXN=5001;
int n, m, a[MAXN][MAXN], dp[MAXN][MAXN], inf = 1e9+7;
char ch;

void read()
{
    cin>>n>>m;
    for(int i=1;i<=n;i++)
    {
        for(int j=1;j<=m;j++)
        {
            cin>>ch;
            if(ch == '#') a[i][j] = 1;
        }
    }
    for(int i=1;i<MAXN;i++)
    {
        for(int j=1;j<MAXN;j++)
        {
            dp[i][j] = inf;
        }
    }
    dp[1][1] = 0;
    for(int i=1;i<=n;i++)
    {
        for(int j=1;j<=m;j++)
        {
            for(int k=dp[i][j]+1;k<=max(n, m);k++)
            {
                if(j-k >= 1 && a[i][j-k] == 0)
                {
                    if(dp[i][j-k] > k)
                    {
                        dp[i][j-k] = k;
                        for(int k1=k+1;k1<=max(n,m);k1++)
                        {
                            if(j+1 <= m && a[i][j+1] == 0) dp[i][j+1] = min(dp[i][j+1], k);
                            if(i+1 <= n && a[i+1][j] == 0) dp[i+1][j] = min(dp[i+1][j], k);
                        }
                    }
                }
                if(i-k >= 1 && a[i-k][j] == 0)
                {
                    if(dp[i-k][j] > k)
                    {
                        dp[i-k][j] = k;
                        for(int k1=k+1;k1<=max(n,m);k1++)
                        {
                            if(j+1 <= m && a[i][j+1] == 0) dp[i][j+1] = min(dp[i][j+1], k1);
                            if(i+1 <= n && a[i+1][j] == 0) dp[i+1][j] = min(dp[i+1][j], k1);
                        }
                    }
                }
                if(j+k <= m && a[i][j+k] == 0) dp[i][j+k] = min(dp[i][j+k], k);
                if(i+k <= n && a[i+k][j] == 0) dp[i+k][j] = min(dp[i+k][j], k);
            }
        }
    }
    if(dp[n][m] == inf) cout<<-1<<endl;
    else cout<<dp[n][m]<<endl;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    read();
    return 0;
}
