#include<bits/stdc++.h>
//#define endl "\n"
using namespace std;

int const MAXN=5001;
int n, d[MAXN][MAXN], a[MAXN][MAXN], inf = 1e9+7, cnt;
vector<int> v[MAXN];
string s;

struct edge
{
    int x, y, dist;
};

vector<edge> p;

void BFS(int i)
{
    queue<int> q;
    q.push(i);
    while(!q.empty())
    {
        int w = q.front();
        q.pop();
        int sz = v[w].size();
        for(int j=0; j<sz; j++)
        {
            int nb = v[w][j];
            if(!d[i][nb])
            {
                cnt++;
                d[i][nb] = d[i][w]+1;
                if(i != nb) p.push_back({i, nb, d[i][nb]});
                q.push(nb);
            }
        }
    }
}

bool cmp(edge i, edge j)
{
    return i.dist < j.dist;
}

void read()
{
    cin>>n;
    for(int i=1; i<n; i++)
    {
        cin>>s;
        for(int j=i+1; j<=n; j++)
        {
            a[i][j] = s[j-i-1] - '0';
            if(a[i][j] == 1)
            {
                v[i].push_back(j);
                v[j].push_back(i);
            }
        }
    }
    int max_comp = 0;
    for(int i=1; i<=n; i++)
    {
        BFS(i);
        max_comp = max(max_comp, cnt);
        cnt = 0;
    }
    if(max_comp < 4)
    {
        cout<<-1<<endl;
        return;
    }
    sort(p.begin(), p.end(), cmp);
    int ans = inf;
    for(int i=0;i<p.size();i++)
    {
        int sz = v[p[i].x].size();
        for(int j=0;j<sz;j++)
        {
            if(v[p[i].x][j] != p[i].y)
            {
                for(int l=0;l<v[p[i].y].size();l++)
                {
                    if(v[p[i].y][l] != v[p[i].x][j] && v[p[i].y][l] != p[i].x)
                    {
                        ans = min(ans, p[i].dist + d[v[p[i].y][l]][v[p[i].x][j]]);
                    }
                }
            }
        }
        if(ans != inf && i<p.size()-1 && p[i].dist < p[i+1].dist) break;
    }
    if(ans == 1e9+7) cout<<-1<<endl;
    else cout<<ans<<endl;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    read();
    return 0;
}
