#include<iostream>
#include<vector>
#include "crption.h"
using namespace std;

int const MAXN=1000001;
int used[MAXN];
vector<int> v[MAXN], ans;

void DFS(int i)
{
    int sz = v[i].size();
    for(int j=0;j<sz;j++)
    {
        int nb = v[i][j];
        if(!used[nb])
        {
            DFS(nb);
        }
    }
    ans.push_back(i);
    used[i] = 1;
}

vector<int> solve (const int &N, const vector<int> &from, const vector<int> &to)
{
    int sz = from.size();
    for(int i=0;i<sz;i++)
    {
        int f = from[i], t = to[i];
        if(check(f,t) == true)
        {
            v[to[i]].push_back(from[i]);
            used[from[i]] = 1;
        }
        else
        {
            v[from[i]].push_back(to[i]);
            used[to[i]] = 1;
        }

    }
    for(int i=1;i<=N;i++)
    {
        if(!used[i])
        {
            DFS(i);
            break;
        }
    }
    return ans;
}
