#include<bits/stdc++.h>

using namespace std;
int n, m;
vector<vector<int>>v;
const int inf=INT_MAX;
void read()
{
    char c;
    cin>>n>>m;
    for(int i=0;i<n;i++)
    {
        v.push_back(vector<int>());
        for(int j=0;j<m;j++)
        {
            cin>>c;
            if(c=='.')
            {
                v[i].push_back(0);
            }
            else v[i].push_back(inf);
        }
    }
    v[n-1][m-1]=inf;
}
struct cell
{
    int x; int y; int t;
    bool inRange()
    {
        return (0<=x&&x<n)&&(0<=y&&y<m);
    }
    cell operator+ (cell c)
    {
        return {c.x+x, c.y+y, c.t+t};
    }
    cell operator* (int _t)
    {
        return {x*_t, y*_t, t};
    }
};
cell dir[5]={{0, 1, 1}, {1, 0, 1}, {0, -1, 1}, {-1, 0, 1}, {0, 0, 1}};
void bfs()
{
    queue<cell>q;
    cell w, nb;
    q.push({0, 0, 1});
    while(!q.empty())
    {
        w=q.front();q.pop();
        //cout<<w.x<<" "<<w.y<<" "<<w.t<<endl;
        for(int i=0;i<4;i++)
        {
            nb=w+dir[i]*w.t;
            //cout<<nb.x<<" "<<nb.y<<" "<<nb.t<<endl;
            if(nb.inRange())
            {
                if(v[nb.x][nb.y]<inf||(nb.x==n-1&&nb.y==m-1))
                {
                    if(v[nb.x][nb.y]>nb.t||v[nb.x][nb.y]==0)
                    {
                        v[nb.x][nb.y]=nb.t;
                        q.push(nb);
                    }
                }
            }
        }
        nb=w+dir[4]*w.t;
        if(v[n-1][m-1]>nb.t&&nb.t<=max(max(n-nb.x, nb.x), max(m-nb.y, nb.y)))
        {
            q.push(nb);
        }
    }
}
int main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
    read();
    bfs();
    if(v[n-1][m-1]==inf)
    {
        //cout<<v[n-1][m-1]<<endl;
        cout<<-1<<endl;
    }
    else cout<<v[n-1][m-1]-1<<endl;
   	return 0;
}
