#include<bits/stdc++.h>
#define endl '\n'

using namespace std;

const int N = 1010, inf = 1e9 + 7;
vector<int> v[N], p[N];
int used[N];
int dist[N][N];
int ans = inf;

void dfs(int ver, int c)
{
    used[ver] = c;
    p[c].push_back(ver);
    for(int i : v[ver]) if(!used[i]) dfs(i, c);
}

void bfs(int ver)
{
    queue<int> q;
    q.push(ver);
    dist[ver][ver] = 0;
    while(!q.empty())
    {
        int w = q.front();
        q.pop();
        for(int i : v[w])
        {
            //cout << ver << " " << i << endl;
            if(dist[ver][i] == inf)
            {

                dist[ver][i] = dist[ver][w] + 1;
                q.push(i);
            }
        }
    }
}

void solve(int u1, int u2)
{
    for(int i : v[u1])
    {
        for(int j : v[u2])
        {
            if(i != j && i != u2 && i != u1 && j != u1 && j != u2 && u1 != u2) ans = min(ans, dist[u1][u2] + dist[i][j]);
        }
    }
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);

    string s;
    int colr = 1, n, x;
    cin >> n;
    for(int i = 1; i <= n; ++i)
        for(int j = 1; j <= n; ++j) dist[i][j] = inf;

    for(int i = 1; i < n; ++i)
    {
        cin >> s;
        for(int j = i + 1; j <= n; ++j)
        {
            //cout << "S = " << s[j - i - 1] << " " << j - i - 1 << endl;
            if(s[j - i - 1] == '1')
            {
                //cout << i << " " << j << endl;
                v[i].push_back(j);
                v[j].push_back(i);
            }
        }
    }
    /*for(int i = 1; i <= n; ++i, cout << endl)
    {
        cout << "v[" << i << "] -> ";
        for(int j : v[i]) cout << j << " ";
    }*/

    for(int i = 1; i <= n; ++i)
    {
        if(!used[i])
        {
            dfs(i, colr);
            colr++;
        }
    }
    for(int i = 1; i <= n; ++i) bfs(i);

    //cout << colr << endl;

    //for(int i = 1; i <= n; ++i, cout << endl)
    //for(int j = 1; j <= n; ++j) cout << dist[i][j] << " ";

    for(int i = 1; i < colr; ++i)
    {
        for(int j = 0; j < p[i].size(); ++j)
        {
            for(int k = 0; k < p[i].size(); ++k)
            {
                solve(p[i][j], p[i][k]);
            }
        }
    }
    cout << ans << endl;
    return 0;
}
/*
11
1110000000
000000000
11000000
0000000
100000
10000
0000
100
10
1

*/
