#include <bits/stdc++.h>
using namespace std;
const long long maxn = 5005;
long long n,m;
long long a[maxn][maxn];
long long dp[maxn][maxn];

void read()
{
    cin >> n >> m;
    for( int i = 1; i <= n; i ++ )
    {
        for( int j = 1; j <= m; j ++ )
        {
            char c;
            cin >> c;
            if( c == '#' ) a[i][j] = 1;
        }
    }
}

void solve()
{
    memset(dp,-1,sizeof(dp));
    dp[1][1] = 0;

    for( int i = 1; i <= n; i ++ )
    {
        for( int j = 1; j <= m; j ++ )
        {
            if( a[i][j] == 1 ) continue;
            if( dp[i][j] == -1 ) continue;

            int t = dp[i][j];

            for( int k = t + 1; k <= n; k ++ )
            {
                if( i + k > n ) break;
                if( a[i+k][j] == 1 ) continue;

                if( dp[i+k][j] == -1 || dp[i+k][j] > k ) dp[i+k][j] = k;
            }

            for( int k = t + 1; k <= m; k ++ )
            {
                if( j + k > m ) break;
                if( a[i][j+k] == 1 ) continue;

                if( dp[i][j+k] == -1 || dp[i][j+k] > k ) dp[i][j+k] = k;
            }
        }
    }

    cout << dp[n][m] << endl;
}
int main()
{
    read();
    solve();
    return 0;
}
