#include <bits/stdc++.h>
using namespace std;
const int maxn = 5005;
int n;
vector<int>v[maxn];
int a[maxn][maxn];
int used[maxn];

void read()
{
    cin >> n;
    for( int i = 1; i < n; i ++ )
    {
        for( int j = i + 1; j <= n; j ++ )
        {
            char x;
            cin >> x;
            if( x == '1' )
            {
                v[i].push_back(j);
                v[j].push_back(i);
            }
        }
    }
}

void bfs( int s )
{
    memset(used,0,sizeof(used));
    used[s] = 1;
    queue<int>q;
    q.push(s);

    while( !q.empty() )
    {
        int w = q.front();
        q.pop();

        int sz = v[w].size();
        for( int i = 0; i < sz; i ++ )
        {
            int nb = v[w][i];
            if( used[nb] == 0 )
            {
                used[nb] = used[w] + 1;
                a[s][nb] = used[nb] - 1;
                q.push(nb);
            }
        }
    }
}

void solve()
{
    memset(a,-1,sizeof(a));
    for( int i = 1; i <= n; i ++ )
    {
        bfs(i);
    }

    /*
    for( int i = 1; i <= n; i ++ )
    {
        for( int j = 1; j <= n; j ++ )
        {
            cout << a[i][j] << " ";
        }
        cout << endl;
    }
    */
}

void get_ans()
{
    int ans = -1;
    for( int i = 1; i <= n; i ++ )
    {
        int u1 = i ,v1;
        int sz = v[i].size();

        for( int j = 0; j < sz; j ++ )
        {
            v1 = v[i][j];
            int sz2 = v[v1].size();

            for( int p = 0; p < sz2; p ++ )
            {
                int u2 = v[v1][p], v2;
                if( p == u1 || p == v1 ) continue;

                int sz1 = v[p].size();

                for( int q = 0; q < sz1; q ++ )
                {
                    v2 = v[p][q];
                    if( v2 == u1 || v2 == v1 ) continue;
                    if( a[u1][u2] == -1 || a[v1][v2] == -1 ) continue;

                    int x = a[u1][u2] + a[v1][v2];
                    if( ans == -1 || x < ans ) ans = x;
                }
            }
        }
    }
    cout << ans << endl;
}

int main()
{
    read();
    solve();
    get_ans();
    return 0;
}
