#include <bits/stdc++.h>
using namespace std;
const int maxn = 555;
int n;
vector<int>v[maxn];
int a[maxn][maxn];
int used[maxn];
bool used1[maxn][maxn];
int lamp = 0;

struct edge
{
    int x;
    int y;
    int idx;

    edge() {};
    edge( int x1,int y1, int idx1 )
    {
        x = x1;
        y = y1;
        idx = idx1;
    }
};

vector<edge>e;

void read()
{
    cin >> n;
    int cnt = 1;
    for( int i = 1; i < n; i ++ )
    {
        for( int j = i + 1; j <= n; j ++ )
        {
            char x;
            cin >> x;
            if( x == '1' )
            {
                v[i].push_back(j);
                v[j].push_back(i);

                e.push_back(edge(i,j,cnt));
                cnt += 1;
            }
        }
    }
}

void bfs( int s )
{
    memset(used,0,sizeof(used));
    used[s] = 1;
    queue<int>q;
    q.push(s);

    int cnt = 1;
    while( !q.empty() )
    {
        int w = q.front();
        q.pop();

        int sz = v[w].size();
        for( int i = 0; i < sz; i ++ )
        {
            int nb = v[w][i];
            if( used[nb] == 0 )
            {
                cnt += 1;
                used[nb] = used[w] + 1;
                a[s][nb] = used[nb] - 1;
                q.push(nb);
            }
        }
    }

    if( cnt >= 4 ) lamp = 1;
}

void solve()
{
    memset(a,-1,sizeof(a));
    for( int i = 1; i <= n; i ++ )
    {
        bfs(i);
    }

    /*
    for( int i = 1; i <= n; i ++ )
    {
        for( int j = 1; j <= n; j ++ )
        {
            cout << a[i][j] << " ";
        }
        cout << endl;
    }
    */
}

void get_ans()
{
    if( lamp == 0 )
    {
        cout << -1 << endl;
        exit(0);
    }
    int ans = -1;
    int sz = e.size();

    for( int i = 0; i < sz; i ++ )
    {
        for( int j = i + 1; j < sz; j ++ )
        {
            int u1 = e[i].x;
            int v1 = e[i].y;

            int u2 = e[j].x;
            int v2 = e[j].y;

            if( u2 == u1 || u2 == v1 ) continue;
            if( v2 == u1 || v2 == v1 ) continue;

            if( a[u1][u2] == -1 || a[v1][v2] == -1 ) continue;

            int x = a[u1][u2] + a[v1][v2];
            int y = a[u1][v2] + a[v1][u2];

            if( ans == -1 || x < ans ) ans = x;
            if( ans == -1 || y < ans ) ans = y;
        }
    }

    cout << ans << "\n";
}
void speed()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
}
int main()
{
    speed();
    read();
    solve();
    get_ans();
    return 0;
}
