#include<bits/stdc++.h>
using namespace std;
const int maxn = 1024;
/*struct Nodeh{
    int x, y, g, h;
    int t;
    Node(){}
    Node(int _x, int _y){
        x = _x;
        y = _y;
        g = 0;
        h = 0;
    }
    Node (int _x, int _y, int _g,int _h){
        x = _x;
        y = _y;
        g = _g;
        h = _h
    }
    bool operator<(const Node &other)const{
        return g + h > other.g + other.h;
    }
};*/
struct Node{
    int x, y, t, h;
    Node(){}
    Node(int _x, int _y){
        x = _x;
        y = _y;
    }
    Node(int _x, int _y, int _t, int _h){
        x = _x;
        y = _y;
        t = _t;
        h = _h;
    }
    bool operator<(const Node &other)const{
        return t + h > other.t + other.h;
    }
};
int n, m;
set< pair<int, int> > filled;
void read(){
    cin >> n >> m;
    for (int i = 1; i <= n; ++i){
        string s;
        cin >> s;
        for (int j = 0; j < m; ++j)
            if (s[j] == '#')
                filled.insert({i,j+1});
    }
}
int heuristic(pair<int,int> cell){
    int dx = n - cell.first;
    int dy = m - cell.second;
    return sqrt(dx * dx + dy * dy);
}
/*Node getcell
vector <Node> getnb(Node st){
    if (st.x < n)
}*/
bool is_valid(pair<int,int> cell){
    if (filled.find(cell) != filled.end())return false;
    if (cell.first < 1 || n < cell.first)return false;
    if (cell.second < 1 || m < cell.second)return false;
    return true;
}
void Astar(){
    auto setNodeCmp = [](Node c, Node d){
        if (c.x != d.x) return c.x < d.x;
        return c.y < d.y;
    };
    //set <Node , decltype(setNodeCmp)> used(setNodeCmp);
    priority_queue<Node> q;
    q.push(Node(1, 1, 1, heuristic({1,1})));
    Node cur;
    while(!q.empty()){
        cur = q.top();
        q.pop();
        //cout <<"curent cell: "<< cur.x << " " << cur.y << " " << cur.t << "\n";
        if (cur.t > max (n,m))
            continue;
        if (cur.x == n && cur.y == m)
            break;
        int pt = cur.t+1;
        q.push(Node(cur.x, cur.y, pt, cur.h));
        /*for (int i = 0; i < 4; ++i)
            switch(i){
                case 0:if (is_valid({cur.x - cur.t, cur.y}))
                        q.push(Node(cur.x - cur.t, cur.x, pt));
                     break;
                case 1:if (is_valid({cur.x, cur.y + cur.t}))
                        q.push(Node(cur.x, cur.y + cur.t, pt));
                    break;
                case 2:if (is_valid({cur.x + cur.t, cur.y}))
                            q.push(Node(cur.x + cur.t, cur.y, pt));
                    break;
                case 3:if (is_valid({cur.x, cur.y - pt}))
                            q.push(Node(cur.x, cur.y - cur.t, pt));
                    break;
            }*/
            //cout << "cell to check: "<<cur.x<< " " << cur.y+cur.t<<endl;
            if (is_valid({cur.x, cur.y + cur.t}))
                q.push(Node(cur.x, cur.y + cur.t, pt, heuristic({cur.x, cur.y + cur.t})));
            //else cout << "The cell is not valid\n";
            //cout << "cell to check: "<<cur.x+cur.t<<" "<< cur.y <<endl;
            if (is_valid({cur.x + cur.t, cur.y}))
                q.push(Node(cur.x + cur.t, cur.y, pt, heuristic({cur.x + cur.t, cur.y})));
            //else cout << "The cell is not valid\n";

    }
    if (cur.x == n && cur.y == m)
        cout <<cur.t -1 << endl;
    else cout << -1 << endl;
}
int main(){
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    /*cin >> n >> m;
    while(true){
        pair <int,int> p;
        cin >> p.first >> p.second;
        cout << is_valid(p) << endl;
    }*/
    read();
    Astar();
    return 0;
}
/*
5 8
.###.##.
##...##.
........
.##.....
.######.
*/
