#include<bits/stdc++.h>
using namespace std;
const int maxn = 5010, inf = 1e9+7;
const unsigned int dinf = (int) -1;
vector<int> v[maxn];
int n;
int dist[maxn][maxn];
int used[maxn];
void read(){
    cin >> n;
    for(int i = 1; i < n; ++i){
        string s;
        cin >> s;
        for (int j = 0; j < s.size(); ++j)
            if (s[j] == '1'){
                v[i].push_back(i+j+1);
                v[i+j+1].push_back(i);
            }
    }
    /*for (int i = 1; i <= n; ++i){
        cout << i << ": ";
        for (auto j : v[i])
            cout << j << " ";
        cout << endl;
    }*/
}
void calcdist(){
    for (int i = 1; i <= n; ++i){
        memset(used, 0, sizeof(used));
        used[i] = 1;
        queue<int>q;
        q.push(i);
        while(!q.empty()){
            int ver = q.front();
            q.pop();
            //cout << ver << " " << used[ver]<< endl;
            for (auto cur:v[ver]){
                int nb = cur;
                if (used[nb] == 0){
                    used[nb] = used[ver] + 1;
                    q.push(nb);
                }
            }
        }
        for (int j = 1; j <= n ; ++j){
            //cout << used[j] << " ";
            dist[i][j]=used[j]-1;
        }
        //cout << endl;
    }
    /*for (int i = 1;i <=n;++i, cout << endl)
        for (int j = 1; j <=n;++j)
            cout<<dist[i][j]<<" ";*/
}
bool differ(int u1, int u2, int v1, int v2){
    if (u1 == u2 || u1 == v1 || u1 == v2)return false;
    if (u2 == v1 || u2 == v2) return false;
    if (v1 == v2) return false;
    return true;
}
void compare(int u1, int v1, int u2, int v2, int &ans){
    if (dist[u1][v1] == 1 && dist[u2][v2] == 1){
        if (dist[u1][u2] != -1 && dist[v1][v2] != -1){
            ans = min(ans, dist[u1][u2] + dist [v1][v2]);
        }
    }
}
void find_intresting(){
    int ans = inf;
    for (int u1 = 1; u1 <= n; ++u1){
        for (int v1 = 1; v1 <= n; v1++){
            for (int u2 = 1; u2 <= n;  u2 ++){
                for (int v2 = 1; v2 <= n; v2++){
                    if (differ(u1, u2, v1, v2)){
                        compare(u1, v1, u2, v2, ans);
                        compare(u1, v2, u2, v1, ans);
                        compare(u1, u2, v1, v2, ans);
                    }
                }
            }
        }
    }
    if (ans == inf)
        cout <<"-1\n";
    else cout << ans << endl;
}
int main(){
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    read();
    calcdist();
    //cout <<"here\n";
    find_intresting();
    return 0;
}
