#include "crption.h"
#include <bits/stdc++.h>
using namespace std;
const int maxn = 1e5+10;
int used[maxn];
vector<int>v[maxn];
vector<int>top_sort;
void build_graph(const vector<int> &from, const vector<int> &to){
    int m = from.size();
    for (int i = 0; i < m; ++i){
        if (check(from[i], to[i]))
            v[from[i]].push_back(to[i]);
        else v[to[i]].push_back(from[i]);
    }
}
void DFS(int ver){
    used[ver]=1;
    for (auto i:v[ver])
        if (!used[i])
            DFS(i);
    top_sort.push_back(ver);
}
vector<int> solve(const int &N, const vector<int> &from, const vector<int> &to){
    build_graph(from, to);
    for (int i = 0;i < N; ++i)
        if (!used[i])DFS(i);
    /*for (auto i:top_sort)
        cout << i << " ";
    cout << endl;*/
    return top_sort;
}
