#include <bits/stdc++.h>
#define endl '\n'
using namespace std;

const int INF = 2e6;
int n, m;
vector <string> v;

map <tuple<int,int>, int> mp;

int rec(int r, int c, int t = 1)
{
    int ret = 0;

//    cerr << "t = " << t << " : " << r << " " << c << " " << endl;

    if (r < 1 || c < 1 || r > n || c > m) return INF;
    if (t >= max(n, m)) return INF;
    if (r == n && c == m) return t-1;
    if (v[r][c] == '#') return INF;

    if (mp[{r, c}]) return mp[{r, c}];

    int p0 = rec(r, c, t+1);
    int p1 = rec(r-t, c, t+1);
    int p2 = rec(r, c-t, t+1);
    int p3 = rec(r+t, c, t+1);
    int p4 = rec(r, c+t, t+1);

    ret = INF;
    if (p0 < ret) ret = p0;
    if (p1 < ret) ret = p1;
    if (p2 < ret) ret = p2;
    if (p3 < ret) ret = p3;
    if (p4 < ret) ret = p4;

    return mp[{r, c}] = ret;
}

int main ()
{
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    cin >> n >> m;
    v.resize(n+1);
    for (int i = 1; i <= n; i++)
    {
        cin >> v[i];
        v[i] = "#" + v[i];
//        cerr << v[i] << endl;
    }
    int ans = rec(1, 1);
    if (ans == INF) ans = -1;

    cout << ans << endl;

    return 0;
}
/**
1 6
..#...


4
*/
