#include <bits/stdc++.h>
#define endl '\n'
using namespace std;

const int MAXN = 5000 + 5;
int t[MAXN][MAXN];
int n;

const int INF = 2e9;

int main ()
{
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    cin >> n;
    string tmp; getline(cin, tmp);
    for (int i = 1; i <= n; i++)
    {
        for (int j = 1; j <= n; j++)
        {
            if (i != j)
                t[i][j] = INF;
        }
    }
    for (int i = 1; i < n; i++)
    {
        for (int j = i+1; j <= n; j++)
        {
            char c;
            cin >> c;
            if (c == '1')
            {
                t[i][j] = 1;
                t[j][i] = 1;
            }
        }
        getline(cin, tmp);
    }

//    for (int i = 1; i <= n; i++)
//    {
//        for (int j = 1; j <= n; j++)
//        {
//            for (int k = 1; k <= n; k++)
//            {
//                if (t[i][k] + t[k][j] < t[i][j])
//                {
//                    t[i][j] = t[i][k] + t[k][i];
//                }
//            }
//        }
//    }

    int ans = 0;

    for (int v1 = 1; v1 <= n; v1++)
    {
        for (int v2 = 1; v2 <= n; v2++)
        {
            for (int u1 = 1; u1 <= n; u1++)
            {
                for (int u2 = 1; u2 <= n; u2++)
                {
                    if (v1 == v2) continue;
                    if (v1 == u1) continue;
                    if (v1 == u2) continue;
                    if (v2 == u1) continue;
                    if (v2 == u2) continue;
                    if (u1 == u2) continue;

                    if (t[u1][v1] != 1) continue;
                    if (t[u2][v2] != 1) continue;
                    if (t[u1][u2] == INF) continue;
                    if (t[v1][v2] == INF) continue;

                    ans = max(ans, t[u1][u2] + t[v1][v2]);
                }
            }
        }
    }

//    for (int i = 1; i <= n; i++)
//    {
//        for (int j = 1; j <= n; j++)
//        {
//            if (t[i][j] == INF) cerr << -1;
//            else cerr << t[i][j];
//            cerr << " ";
//        }cerr << endl;
//    }

    cout << ans << endl;

    return 0;
}
/**
4
111
11
1

4
110
01
1

*/
