#include <bits/stdc++.h>
#define endl '\n'
using namespace std;

const int INF = 2e9;
const int MAXN = 550 + 5;
int t[MAXN][MAXN];
int n;

vector <int> G[MAXN];
bool used[MAXN];
int dist[MAXN];

//void bfs(int x)
//{
//    memset(used, 0, sizeof(used));
//    for (int j = 1; j <= n; j++)
//        dist[j] = INF;
//
//    queue <int> q;
//
//    dist[x] = 0;
//    used[x] = 1;
//
//    q.push(x);
//
//    while (!q.empty())
//    {
//        int x = q.front();
//        q.pop();
//
//        for (int i = 0; i < G[x].size(); i++)
//        {
//            if (dist[x] + 1 < dist[G[x][i]])
//            {
//                dist[G[x][i]] = dist[x] + 1;
//            }
//            if (!used[G[x][i]])
//            {
//                q.push(G[x][i]);
//                used[G[x][i]] = 1;
//            }
//        }
//    }
//}

int main ()
{
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    cin >> n;
//    string tmp; getline(cin, tmp);
    for (int i = 1; i <= n; i++)
    {
        for (int j = 1; j <= n; j++)
        {
            if (i != j)
                t[i][j] = INF;
        }
    }
    for (int i = 1; i < n; i++)
    {
        for (int j = i+1; j <= n; j++)
        {
            char c;
            cin >> c;
            if (c == '1')
            {
                t[i][j] = 1;
                t[j][i] = 1;
//                G[i].push_back(j);
//                G[j].push_back(i);
            }
        }
//        getline(cin, tmp);
    }

//    for (int i = 1; i <= n; i++)
//    {
//        bfs(i);
//
//        for (int j = 1; j <= n; j++)
//            t[i][j] = dist[j];
//    }


    for (int i = 1; i <= n; i++)
    {
        for (int j = 1; j <= n; j++)
        {
            for (int k = 1; k <= n; k++)
            {
                if (t[i][k] + t[k][j] < t[i][j])
                {
                    t[i][j] = t[i][k] + t[k][j];
                }
            }
        }
    }

//    for (int i = 1; i <= n; i++)
//    {
//        for (int j = 1; j <= n; j++)
//        {
//            cout << t[i][j] << " ";
//        }
//        cout << endl;
//    }


    int ans = INF;

    for (int v1 = 1; v1 <= n; v1++)
    {
        for (int v2 = 1; v2 <= n; v2++)
        {
            for (int u1 = 1; u1 <= n; u1++)
            {
                for (int u2 = 1; u2 <= n; u2++)
                {
                    if (v1 == v2) continue;
                    if (v1 == u1) continue;
                    if (v1 == u2) continue;
                    if (v2 == u1) continue;
                    if (v2 == u2) continue;
                    if (u1 == u2) continue;

                    if (t[u1][v1] != 1) continue;
                    if (t[u2][v2] != 1) continue;
                    if (t[u1][u2] == INF) continue;
                    if (t[v1][v2] == INF) continue;


//                    cerr << v1 << " " << v2 << " " << u1 <<  " " << u2 << " = " << t[u1][u2] + t[v1][v2] << endl;

                    ans = min(ans, t[u1][u2] + t[v1][v2]);
                }
            }
        }
    }

//    for (int i = 1; i <= n; i++)
//    {
//        for (int j = 1; j <= n; j++)
//        {
//            if (t[i][j] == INF) cerr << -1;
//            else cerr << t[i][j];
//            cerr << " ";
//        }cerr << endl;
//    }

    if (ans == INF) ans = -1;

    cout << ans << endl;

    return 0;
}
/**
4
111
11
1

4
110
01
1


10
101110101
11101101
1111011
101111
11101
1011
011
11
1


0 1 2 1 1 1 2 1 3 1
1 0 1 1 1 2 1 1 3 1
2 1 0 1 1 1 1 2 1 1
1 1 1 0 1 2 1 1 1 1
1 1 1 1 0 1 1 1 4 1
1 2 1 2 1 0 1 2 1 1
2 1 1 1 1 1 0 2 1 1
1 1 3 1 1 2 3 0 1 1
3 2 1 1 2 1 1 1 0 1
1 1 1 1 1 1 1 1 1 0

*/
