#include<iostream>
#include<vector>
#include<tuple>
#include<algorithm>
#include<cstring>
using namespace std;
const int MAX_N=5e3+3;
vector<int>g[MAX_N];
int n;
int used[MAX_N];
int ans;
bool is;
int verts;
int deg[MAX_N];
int cnt1;
int parent[MAX_N];
bool ok[MAX_N][MAX_N];
void DFS(int u,int par)
{
    used[u]=1;
    verts++;
    if(deg[u]==1)cnt1++;
    for(int v:g[u])
    {
        if(v==par)continue;
        if(used[v])
        {
            is=1;
            continue;
        }
        parent[v]=u;
        DFS(v,u);
    }
}
int co[MAX_N][MAX_N];
int pr[MAX_N][MAX_N];
int main ()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    cin>>n;
    ans=2e9;
    for(int i=1;i<n;i++)
    {
        string s;
        cin>>s;
        for(int j=i+1;j<=n;j++)
        {
            if(s[j-i-1]=='1')
            {
                ok[i][j]=ok[j][i]=1;
                deg[j]++;
                deg[i]++;
                g[j].push_back(i);
                g[i].push_back(j);
            }
        }
    }
int i,j,k;
    for(i=1;i<=n;i++)
    {
        for(j=i+1;j<=n;j++)
        {
            for(k=1;k<=n;k++)
            {
                if(k==i or k==j)continue;
                if(ok[i][k] && ok[k][j])
                {
                    pr[i][j]=k;
                    co[i][j]++;
                }
            }
            if(co[i][j]>1)
            {
                cout<<2<<"\n";
                return 0;
            }
        }
    }

    for(i=1;i<=n;i++)
    {
        for(j=i+1;j<=n;j++)
        {
            for(k=1;k<=n;k++)
            {
                if(k==i or k==j)continue;
                if((pr[i][j]==k ? co[i][j]>1 : co[i][j]>0) && co[k][j] && ok[i][k])
                {
                    ans=min(ans,3);
                    break;
                }
            }
        }
    }
    //penta i tri
    for(i=1;i<=n;i++)
    {
        for(j=i+1;j<=n;j++)
        {
            for(k=1;k<=n;k++)
            {
                if(k==i or k==j)continue;
                if(ok[i][k] && ok[k][j])
                {
                    if((deg[i]>2 or deg[k]>2 or deg[j]>2) && ok[i][j]){ans=min(ans,3);break;}
                }
            }
        }
    }
    //tri i tetra

    for(int i=1;i<=n;i++)
    {
        if(!used[i])
        {
            cnt1=0;
            verts=0;
            is=0;
            DFS(i,0);
            if(!is)
            {
                if(verts>=4 && cnt1!=verts-1)
                {
                    ans=min(ans,4);
                }
            }
            else
            {
                if(verts>=4)ans=min(ans,4);
            }
        }
    }

    if(ans==2e9)ans=-1;
    cout<<ans<<"\n";

    return 0;
}
