//#include <bits/stdc++.h>
#include <iostream>
#include <vector>
#include <queue>
using namespace std;
const int MAXN = 5001;
struct Vertex{
    int ind;
    int prev;
    int step;
};
vector<int> neighbours[MAXN];
bool visited[MAXN];
int walk(int curr, int prev, int step) {
//    cout << curr << ' ' << prev << ' ' << step << '\n';
    if (visited[curr]) {
        if (step > 3) {
            return step - 2;
        } else {
            return MAXN;
        }
    }
    visited[curr] = true;
    int minn = MAXN;
    if (step == 3) {
        minn = 4;
    }
    for (auto it : neighbours[curr]) {
        if (it != prev) {
            minn = min(minn, walk(it, curr, step + 1));
        }
    }
    visited[curr] = false;
    return minn;
}
void visit(int curr) {
    if (!visited[curr]) {
        visited[curr] = true;
        for (auto it : neighbours[curr]) {
            visit(it);
        }
    }
}
int main() {
//    ios_base::sync_with_stdio(false);
//    cin.tie(0);
//    cout.tie(0);

    int n;
    cin >> n;
    for (int i = 1; i < n; i++) {
        visited[i] = false;
        string v;
        cin >> v;
        for (int j = 1; j + i <= n + 1; j++) {
            if (v[j - 1] == '1') {
                neighbours[i].push_back(i + j);
                neighbours[i + j].push_back(i);
//                cout << i << ' ' << i + j << '\n';
            }
        }
    }
//    for (int i = 1; i <= n; i++) {
//        cout << i << ' ';
//        for (auto it : neighbours[i]) {
//            cout << it << ' ';
//        }
//        cout << '\n';
//    }
    int minn = MAXN;
    for (int i = 1; i <= n; i++) {
        if (!visited[i]) {
            minn = min(minn, walk(i, 0, 0));
            visit(i);
        }
    }
    if (minn == MAXN) {
        cout << -1;
    } else {
        cout << minn;
    }
//    int min_cycle = MAXN;
//    bool four = false;
//    for (int i = 1; i <= n; i++) {
//        if (!visited[i]) {
//            queue<Vertex> que;
//            Vertex tool;
//            tool.ind = i;
//            tool.prev = 0;
//            tool.step = 0;
//            que.push(tool);
//            while ( !que.empty() ) {
//                Vertex curr = que.front();
//                que.pop();
//
//                if (visited[curr.ind]) {
//                    if (curr.step > 3) {
//                        min_cycle = min(min_cycle, curr.step);
//                    }
//                } else {
//                    if (curr.step == 3) {
//                        four = true;
//                    }
//                    visited[curr.ind] = true;
//                    for (auto it : neighbours[curr.ind]) {
//                        if (it != curr.prev) {
//                            Vertex tool2;
//                            tool2.ind = it;
//                            tool2.prev = curr.ind;
//                            tool2.step = curr.step + 1;
//                            que.push(tool2);
//                        }
//                    }
//                }
//            }
//        }
//    }
//    if (min_cycle == MAXN && !four) {
//        cout << -1;
//    } else if (min_cycle <= 5) {
//        cout << min_cycle - 2;
//    } else if (four) {
//        cout << 4;
//    } else {
//        cout << min_cycle - 2;
//    }
    return 0;
}

