//#include <bits/stdc++.h>
#include <iostream>
#include <vector>
#include <queue>
using namespace std;
const int MAXN = 5001;
struct Vertex{
    int ind;
    int prev;
    int step;
};
vector<int> neighbours[MAXN];
bool visited[MAXN];
bool walked[MAXN];
int walk(int curr, int prev, int step, int minn) {
    if (step > minn + 5) {
        return MAXN;
    }
    walked[curr] = true;
    if (visited[curr]) {
        if (step > 3) {
            return step - 2;
        } else {
            return MAXN;
        }
    }
    visited[curr] = true;
    if (step == 3) {
        minn = 4;
    }
    for (auto it : neighbours[curr]) {
        if (it != prev) {
            minn = min(minn, walk(it, curr, step + 1, minn));
        }
    }
    visited[curr] = false;
    return minn;
}
int main() {
//    ios_base::sync_with_stdio(false);
//    cin.tie(0);
//    cout.tie(0);

    int n;
    cin >> n;
    for (int i = 1; i < n; i++) {
        visited[i] = false;
        walked[i] = false;
        string v;
        cin >> v;
        for (int j = 1; j + i <= n + 1; j++) {
            if (v[j - 1] == '1') {
                neighbours[i].push_back(i + j);
                neighbours[i + j].push_back(i);
//                cout << i << ' ' << i + j << '\n';
            }
        }
    }
//    for (int i = 1; i <= n; i++) {
//        cout << i << ' ';
//        for (auto it : neighbours[i]) {
//            cout << it << ' ';
//        }
//        cout << '\n';
//    }
    int minn = MAXN;
    for (int i = 1; i <= n; i++) {
        if (!walked[i]) {
            minn = min(minn, walk(i, 0, 0, MAXN));
        }
    }
    if (minn == MAXN) {
        cout << -1;
    } else {
        cout << minn;
    }
    return 0;
}

