#include<iostream>
#include<queue>
#include<algorithm>
#pragma GCC optimize("O3")
#define endl '\n'
using namespace std;
int n,m,md[2005][2005];
const int INF=10000005;
string a[5005];
bool used[2005][2005];
struct str
{
    int r1,c1,st;
    str(int a1,int a2,int a3)
    {
        r1=a1;c1=a2;st=a3;
    }
};
priority_queue< str > q;
bool operator<(str a1, str b1)
{
    return a1.st>b1.st;
}
int main()
{
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    cin>>n>>m;


    for(int i=0;i<n;i++)
    {
        cin>>a[i];
        for(int j=0;j<m;j++)
        {
            md[i][j]=INF;
            if(a[i][j]=='#') md[i][j]=-1;
        }
    }

    q.push(str(0,0,0));
    md[0][0]=0;

    int tim=max(m,n);
    pair<int,int> cell;

    while(!q.empty())
    {
         cell={q.top().r1,q.top().c1};
         int mintim=q.top().st;

      //  cout<<cell.first<<" "<<cell.second<<" "<<mintim<<" "<<tim<<endl;

        q.pop();

        if(cell.first==n-1 && cell.second==m-1)
        {
            cout<<md[cell.first][cell.second]<<endl;

            return 0;
        }

        if(used[cell.first][cell.second]) continue;

        used[cell.first][cell.second]=1;

        for(int t=mintim+1;t<=tim;t++)
        {
                if(cell.first>=t && md[cell.first-t][cell.second]>t)
                {
                    md[cell.first-t][cell.second]=t;
                    q.push(str(cell.first-t,cell.second,t));
                }

                 if(cell.second>=t &&  md[cell.first][cell.second-t]>t)
                {
                    md[cell.first][cell.second-t]=t;
                    q.push(str(cell.first,cell.second-t,t));
                }

                if(cell.first<n-t && md[cell.first+t][cell.second]>t)
                {
                    md[cell.first+t][cell.second]=t;
                    q.push(str(cell.first+t,cell.second,t));
                }

                  if(cell.second<m-t && md[cell.first][cell.second+t]>t)
                {
                    md[cell.first][cell.second+t]=t;
                    q.push(str(cell.first,cell.second+t,t));
                }
        }
    }

  cout<<-1<<endl;
  return 0;
}
