#include<iostream>
#include<vector>
#include<queue>
using namespace std;
#define MAXN 2200
#define MAXM 2500000
vector<int> susedi[MAXN];
vector<pair<int,int>> rebra;
int razst[MAXN][MAXN];
priority_queue<pair<int,int>> q;
void dijkstra(int vr){
    int original = vr;
    q.push({0,vr});
    int dist;
    while(!q.empty()){
        vr = q.top().second;
        dist = q.top().first;
        q.pop();
        //cout<<"za "<<original<<" sme vyv "<<vr<<" s dist = "<<dist<<"\n";
        for(auto to : susedi[vr]){
            if(razst[original][to]>dist+1){
                razst[original][to]=dist+1;
                //cout<<"     i podobrqvame razst na "<<to<<" = "<<dist+1<<"\n";
                q.push({dist+1,to});
            }
        }
    }
}
int main () {
    int n;
    cin>>n;
    string a;
    int ind;
    for(int i=1;i<n;i++){
        cin>>a;
        ind = i+1;
        for(int j=0;j<a.size();j++){
            //cout<<"pitam za "<<i<<" "<<j<<" ";
            if(a[j]=='1'){
                susedi[i].push_back(ind);
                susedi[ind].push_back(i);
                rebra.push_back({i,ind});
            }
            ind++;
        }
    }
    for(int i=1;i<=n;i++){
        for(int j=1;j<=n;j++){
            if(i!=j) razst[i][j]=MAXM;
        }
        dijkstra(i);
    }
    /*for(int i=1;i<=n;i++){
        for(int j=1;j<=n;j++){
            cout<<i<<" "<<j<<" "<<razst[i][j]<<"\n";
        }
    }*/
    int ans = MAXM;
    for(int i=1;i<=n;i++){
        for(int j=1;j<=n;j++){
            for(int p=1;p<=n;p++){
                for(int q=1;q<=n;q++){
                    if(i==j or i==p or i==q or j==p or j==q or p==q) continue;
                    if(razst[i][j]==1 and razst[p][q]==1 and razst[i][p]<MAXM and razst[j][q]<MAXM){
                        ans = min(ans,razst[i][p]+razst[j][q]);
                    }
                }
            }
        }
    }
    cout<<ans<<"\n";
    return 0;
}
