#include <bits/stdc++.h>

#include "crption.h"

#ifdef __LOCAL__
#include "Lgrader.cpp"
#endif // __LOCAL__

using namespace std;

const int MAXN = 1e5 + 50;

int Graph[MAXN];

vector <int> solve (const int &N, const vector <int> &from, const vector<int> &to)
{
    memset(Graph, -1, sizeof(Graph));

    int M = from.size();

    int64_t source = (n)*(n-1)/2;
    for (int i = 0; i < M; i++)
    {
        int u = from[i];
        int v = to[i];
        bool res = check(u, v);

        if (res == true)
            swap(u, v);

        Graph[u] = v;

        source -= int64_t(v);
    }

    vector <int> ans(N);
    int ind = 0;

    while (source != -1)
    {
        ans[ind++] = source;
        source = Graph[source];
    }

    return ans;

}
