#include<bits/stdc++.h>
#define endl '\n'

using namespace std;
typedef long long ll;

void speed()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
}

const int maxn = 5010, inf = 1e9;

int n, f[maxn][maxn];
void solve()
{
    cin >> n;
    for (int i = 1; i <= n; i ++)
        for (int j = 1; j <= n; j ++)
    {
        f[i][j] = inf;
        if (i == j)
            f[i][j] = 0;
    }

    for (int i = 1; i <= n; i ++)
        for (int j = i + 1; j <= n; j ++)
    {
        char c;
        cin >> c;
        f[i][j] = f[j][i] = c - '0';
    }

    for (int k = 1; k <= n; k ++)
        for (int i = 1; i <= n; i ++)
        for (int j = 1; j <= n; j ++)
    {
        if (f[i][k] + f[k][j] < f[i][j])
        {
            f[i][j] = f[i][k] + f[k][j];
        }
    }

    int ans = inf;
    for (int u1 = 1; u1 <= n; u1 ++)
        for (int v1 = 1; v1 <= n; v1 ++)
        for (int u2 = 1; u2 <= n; u2 ++)
        for (int v2 = 1; v2 <= n; v2 ++)
    {
        if (u1 == v1 || u1 == u2 || u1 == v2)
            continue;
        if (v1 == u2 || v1 == v2)
            continue;
        if (u2 == v2)
            continue;
        if (f[u1][v1] == 1 && f[u2][v2] == 1)
        {
            ans = min(ans, f[u1][u2] + f[v1][v2]);
        }
    }

    if (ans == inf)
        cout << -1 << endl;
    else
        cout << ans << endl;
}

int main()
{
    solve();
    return 0;

}
