#include <bits/stdc++.h>
#include "crption.h"

using namespace std;

const int maxn = 1e5 + 10;
int in_deg[maxn], nxt[maxn];
vector < int > g[maxn], ord;

void topsort(int v)
{
    for (int u : g[v])
    {
        topsort(u);
    }
    ord.push_back(v);
}
vector<int> solve(const int &n, const vector<int> &from, const vector<int> &to)
{
    int root = -1, m = from.size();
    for (int i = 0; i < m; i ++)
    {
        int v, u;
        v = from[i];
        u = to[i];
        if (check(v, u))
            swap(v, u);
            in_deg[u] ++;
            g[v].push_back(u);
            ///cout << "edge " << v << " " << u << endl;
    }

    root = 0;
    while(in_deg[root] > 0)
        root ++;
    topsort(root);
    reverse(ord.begin(), ord.end());
    return ord;
}

