#include <bits/stdc++.h>
#include "crption.h"

using namespace std;

const int maxn = 1e5 + 10, maxk = 20;
int used[maxn], in_deg[maxn], out_deg[maxn], nxt[maxn];
vector < int > g[maxn], ord;

void topsort(int v)
{
    used[v] = 1;
    for (int u : g[v])
    {
        if (!used[u])
            topsort(u);
    }
    ord.push_back(v);
}

int edge[1010][1010], safe[1010][1010];
vector<int> solve(const int &n, const vector<int> &from, const vector<int> &to)
{
    int root, m = from.size();
    for (int i = 0; i < m; i ++)
    {
        int v, u;
        v = from[i];
        u = to[i];
        in_deg[u] ++;
        out_deg[v] ++;
        edge[v][u] = 1;
        ///cout << "edge " << v << " " << u << endl;
    }

    for (int step = 0; step < n; step ++)
    {

        vector < int > pos_root;
        for (int v = 0; v < n; v ++)
        {
            if (used[v])
                continue;
            if (in_deg[v] > maxk)
                continue;
            bool tf = true;
            for (int u = 0; u < n; u ++)
            {
                if (edge[u][v] == 0)
                    continue;
                if (safe[u][v])
                {
                    tf = false;
                    break;
                }
                if (check(u, v) == true)
                {
                    edge[u][v] = 0;
                    edge[v][u] = 1;
                    safe[v][u] = 1;
                    in_deg[v] --;
                    out_deg[v] ++;
                    in_deg[u] ++;
                    out_deg[u] --;
                    tf = false;
                    break;
                }

            }
            if (tf)
                pos_root.push_back(v);
        }

        //for (int mb : pos_root)
          //  cout << mb << " ";
        ///cout << endl;
        int root = pos_root[0];
        while(true)
        {
            bool tf = false;
            for (int i = 0; i < pos_root.size(); i ++)
            {
                int v = pos_root[i];
                if (v == root)
                    continue;
                if (edge[root][v] && !safe[root][v])
                {
                    ///cout << "here " << root << " " << v << endl;
                    if (check(root, v) == true)
                    {
                        edge[root][v] = 0;
                        edge[v][root] = 1;
                        safe[v][root] = 1;
                        in_deg[v] --;
                        out_deg[v] ++;
                        in_deg[root] ++;
                        out_deg[root] --;
                        root = v;
                        tf = true;
                        break;
                    }
                    else
                    {
                        safe[root][v] = 1;
                    }
                }
                else if (edge[v][root])
                {

                    if (safe[v][root])
                    {
                        root = v;
                    }
                    else
                    {
                        if (check(v, root) == true)
                        {
                            edge[v][root] = 0;
                            edge[root][v] = 1;
                            safe[root][v] = 1;
                            in_deg[root] --;
                            out_deg[root] ++;
                            in_deg[v] ++;
                            out_deg[v] --;
                        }
                        else
                        {
                            safe[v][root] = 1;
                            root = v;
                        }
                    }
                }
            }
            if (!tf)
                break;
        }

        ord.push_back(root);
        used[root] = 1;
        for (int u = 0; u < n; u ++)
        {
            if (edge[root][u])
            {
                edge[root][u] = 0;
                in_deg[u] --;
                out_deg[root] --;
            }
        }
    }


    return ord;
}
