#include <bits/stdc++.h>
#include "crption.h"

using namespace std;

const int maxn = 1e5 + 10;
int used[maxn], in_deg[maxn], nxt[maxn];
vector < int > g[maxn], ord;

void topsort(int v)
{
    used[v] = 1;
    for (int u : g[v])
    {
        if (!used[u])
        topsort(u);
    }
    ord.push_back(v);
}
vector<int> solve(const int &n, const vector<int> &from, const vector<int> &to)
{
    int root, m = from.size(), cnt = 0;
    vector < int > idx;
    for (int i = 0; i < m; i ++)
        idx.push_back(i);
    random_shuffle(idx.begin(), idx.end());
    for (int p = 0; p < m; p ++)
    {
        int i = idx[i];
        int v, u;
        v = from[i];
        u = to[i];
        if (cnt == 20 && check(v, u))
            swap(v, u), cnt ++;
        in_deg[u] ++;
        g[v].push_back(u);
        ///cout << "edge " << v << " " << u << endl;
    }


    root = 0;
    while(root < n && in_deg[root] > 0)
        root ++;

    topsort(root);
    reverse(ord.begin(), ord.end());
    return ord;
}
